/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogItalkServer.cxx


#include	<winsock2.h>
#include "DialogOrderedList.h"


class DialogItalkServer : public DialogOrderedList
{
public:
  DialogItalkServer(HWND _hwnd)
    : DialogOrderedList(_hwnd)
  {
  }
  
	// WM_INITDIALOG
	BOOL wmInitDialog(HWND focus, LPARAM lParam)
	{
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );
		registry_name      = "ItalkServer%d";
		new_list_string    = "handle@hostname:port";
		hwnd_edit          = Hwnd(rEditItalkServer);
		hwnd_button_new    = Hwnd(rButtonItalkServerNew);
		hwnd_button_delete = Hwnd(rButtonItalkServerDelete);
		hwnd_button_up     = Hwnd(rButtonItalkServerUp);
		hwnd_button_down   = Hwnd(rButtonItalkServerDown);
		hwnd_list          = Hwnd(rListItalkServer);

		// SetParent(hwnd_edit, hwnd_list);

		char buf[BUFSIZE];
		m_pProfileManager->Read("Handle", buf, sizeof(buf),
				LoadString(rStringDefaultHandle));
		SetWindowText(rEditHandle, buf);
    
		return DialogOrderedList::wmInitDialog(focus, lParam);
	}

  // OK ͍XV
  BOOL wmNotify_psnApply(void)
  {
    BOOL r = DialogOrderedList::wmNotify_psnApply();
    
    // WXg
    char buf[BUFSIZE];
    
    GetWindowText(rEditHandle, buf, sizeof(buf));
    m_pProfileManager->Write("Handle", buf);
    
    SendMessage(HwndPropertySheetOwner(), WM_DIALOGNOTIFY,
		rDialogItalkServer, TRUE);
    return r;
  }
  
  // WM_COMMAND
  BOOL wmCommand(int notify_code, int id, HWND hwnd_control)
  {
    command = notify_code;
    if (id == rEditHandle)
      return wmCommand_EditHandle();
	if (id == rEditItalkServer){
//		int		sel_changing_bak = sel_changing;
//		sel_changing = false;
//		DialogOrderedList::wmCommand(EN_UPDATE, id, hwnd_edit);
//		DialogOrderedList::wmCommand_List(true);
//		sel_changing = sel_changing_bak;
//		command = LBN_SELCHANGE;
//		DialogOrderedList::wmCommand_List(true);
//		return TRUE;
	}
    return DialogOrderedList::wmCommand(notify_code, id, hwnd_control);
  }
  
  BOOL wmCommand_EditHandle(void)
  {
	if (!!(command == EN_UPDATE))
      PropertySheetChanged();
    return TRUE;
  }
};


BOOL CALLBACK DialogItalkServerDlgProc(HWND hwnd, UINT message,
				       WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogItalkServer
  if (!lgwc)
    switch (message)
    {
      lgwmInitDialog;
    }
  else    
    switch (message)
    {
      lgwmCommand;
    }

  return lgwc->Default(message, wParam, lParam, TRUE);
}

