/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogKillName.cxx


#include	<winsock2.h>
#include "DialogOrderedList.h"
#include "WItalk2.h"
#include "lgRegistry.h"

//extern WItalk2* witalk2_ptr;

class DialogKillName : public DialogOrderedList
{
	HWND	hwnd_killcheck;

public:

	static	int		killname;

  DialogKillName(HWND _hwnd)
    : DialogOrderedList(_hwnd)
  {
  }
  
  // WM_INITDIALOG
  BOOL wmInitDialog(HWND focus, LPARAM lParam)
  {
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );

    registry_name      = "KillName%d";
    new_list_string    = "Whom do you want to kill ?";
    hwnd_edit          = Hwnd(rEditKillName);
    hwnd_button_new    = Hwnd(rButtonKillNameNew);
    hwnd_button_delete = Hwnd(rButtonKillNameDelete);
    hwnd_button_up     = Hwnd(rButtonKillNameUp);
    hwnd_button_down   = Hwnd(rButtonKillNameDown);
    hwnd_list          = Hwnd(rListKillName);

    hwnd_killcheck = Hwnd(rCheckEnableKillName);


	int	value;
	m_pProfileManager->Read("EnableKillName", value, 0);
	Button_SetCheck(hwnd_killcheck, value);

    return DialogOrderedList::wmInitDialog(focus, lParam);
  }

  BOOL wmNotify_psnApply(void)
  {
    BOOL r = DialogOrderedList::wmNotify_psnApply();

	// Waffle 0.2.0f-RevC: killname  ON/OFF _CAOɒǉ
	int		value = Button_GetCheck(hwnd_killcheck);
	killname = value;

	m_pProfileManager->Write("EnableKillName", value);

    
    SendMessage(HwndPropertySheetOwner(), WM_DIALOGNOTIFY,
		rDialogKillName, TRUE);
    return r;
  }
};

int		DialogKillName::killname = false;


BOOL CALLBACK DialogKillNameDlgProc(HWND hwnd, UINT message,
				    WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogKillName
  if (!lgwc)
    switch (message)
    {
      lgwmInitDialog;
    }
  else    
    switch (message)
    {
      lgwmCommand;
    }
  return lgwc->Default(message, wParam, lParam, TRUE);
}
