/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogOrderedList.h

#pragma	once

#include "Dialog.h"
#include "lgDialog.h"

#include "ProfileManager.h"


class DialogOrderedList : public lgDialog
{
protected:
  int command;         // WM_COMMAND ̃R}h̎
  BOOL sel_changing;   // IԂω
  
  //Use m_pProfileManager
  //lgRegistry registry; // WXg
  
  char *registry_name; // "OrderdList%d" Ȃ
  char *new_list_string;
  HWND hwnd_edit;
  HWND hwnd_button_new;
  HWND hwnd_button_delete;
  HWND hwnd_button_up;
  HWND hwnd_button_down;
  HWND hwnd_list;

  ProfileManager* m_pProfileManager;
  // rList ̑IԂω
  void sel_changed(BOOL does_update_edit)
  {
    PostMessage(Hwnd(), WM_COMMAND,
		(WPARAM)MAKELONG(
		  does_update_edit ? GetDlgCtrlID(hwnd_list) : 0,
		  LBN_SELCHANGE),
		(LPARAM)hwnd_list);
  }
  
public:
  DialogOrderedList(HWND _hwnd)
    : lgDialog(_hwnd),
      sel_changing(FALSE),
      /*registry(REGISTRY_ROOT),*/
	  m_pProfileManager( NULL )
  {
  }
  
	// WM_INITDIALOG
	// lParam : should be pointer to PROPSHEETPAGE structure
    // m_pProfileManager͔hNXwmInitDialogŏׂ
	BOOL wmInitDialog(HWND /* focus */, LPARAM  /* lParam */)
	{
		/*
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		*/
		_ASSERT( m_pProfileManager != NULL );

		EnableWindow(hwnd_edit         , TRUE /*FALSE*/);
		EnableWindow(hwnd_button_delete, FALSE);
		EnableWindow(hwnd_button_up    , FALSE);
		EnableWindow(hwnd_button_down  , FALSE);
    
		// WXg
		char buf[BUFSIZE];
		for (int i = 0; ; i++)
		{
			char name[BUFSIZE];
			sprintf(name, registry_name, i);
			if (!m_pProfileManager->Read(name, buf, sizeof(buf)))
				break;
			ListBox_AddString(hwnd_list, buf);
		}
		return TRUE;
	}
  
	// OK ͍XV
	BOOL wmNotify_psnApply(void)
	{
		// WXg
		char buf[BUFSIZE];
		char name[BUFSIZE];
		int i;
		for (i = 0; ; i++)
		{
			sprintf(name, registry_name, i);
			if (!m_pProfileManager->Read(name, buf, sizeof(buf))) // ݂邩ǂׂ
				break;
			m_pProfileManager->Delete(name); // ݂Ȃ폜
		}
		for (i = 0; ; i++)
		{
			if (LB_ERR == ListBox_GetText(hwnd_list, i, buf))
				break;
			sprintf(name, registry_name, i);
			m_pProfileManager->Write(name, buf);
		}

		return lgDialog::wmNotify_psnApply();
	}

  // WM_COMMAND
  BOOL wmCommand(int notify_code, int id, HWND hwnd_control)
  {
    command = notify_code;
    if (hwnd_control == hwnd_edit)          return wmCommand_Edit();
    if (hwnd_control == hwnd_button_new)    return wmCommand_ButtonNew();
    if (hwnd_control == hwnd_button_delete) return wmCommand_ButtonDelete();
    if (hwnd_control == hwnd_button_up)     return wmCommand_ButtonUp();
    if (hwnd_control == hwnd_button_down)   return wmCommand_ButtonDown();
    if (hwnd_control == hwnd_list)          return wmCommand_List(!!id);
    return TRUE;
  }
  
  virtual void GetEditText(char *buf, int sizeof_buf)
  {
    GetWindowText(hwnd_edit, buf, sizeof_buf);
  }
  
  virtual void SetEditText(char *buf)
  {
    SetWindowText(hwnd_edit, buf);
  }

  BOOL wmCommand_Edit(void)
  {
	if (command == EN_UPDATE/*EN_CHANGE /*&& !sel_changing*/)
    {
		char buf[BUFSIZE];
      GetEditText(buf, sizeof(buf));
      int i = ListBox_GetCurSel(hwnd_list);
      if (LB_ERR != i)
      {
	ListBox_DeleteString(hwnd_list, i);
	ListBox_InsertString(hwnd_list, i, buf);
	ListBox_SetCurSel(hwnd_list, i);
	sel_changed(FALSE);
	PropertySheetChanged();
      }
    }
    return TRUE;
  }

  BOOL wmCommand_List(BOOL does_update_edit)
  {
    switch (command)
    {
      case LBN_SELCANCEL:
      case LBN_SELCHANGE:
      {
	sel_changing = TRUE;
	BOOL can_delete = TRUE;
	BOOL can_up     = TRUE;
	BOOL can_down   = TRUE;
	int i = ListBox_GetCurSel(hwnd_list);
	if (i == LB_ERR)
	  can_delete = can_up = can_down = FALSE;
	else
	{	
	  char buf[BUFSIZE];
	  if (does_update_edit)
	  {
		ListBox_GetText(hwnd_list, i, buf);
	    SetEditText(buf);
	  }
	  if (i == 0)
	    can_up = FALSE;
	  else if (i == ListBox_GetCount(hwnd_list) - 1)
	    can_down = FALSE;
	}
	
	EnableWindow(hwnd_button_delete, can_delete);
	EnableWindow(hwnd_button_up    , can_up);
	EnableWindow(hwnd_button_down  , can_down);
	EnableWindow(hwnd_edit         , 1/*0 < ListBox_GetCount(hwnd_list)*/);
	
	sel_changing = FALSE;
	break;
      }
    }
    return TRUE;
  }
  
  	/* Waffle 0.1.11: VKł͂Ȃ "ǉ" ɎdlύXB
	   RichEdit ł́AȂ EN_UPDATE ̃bZ[WłȂ߁AA^CύXłȂB */
  BOOL wmCommand_ButtonNew(void)
  {
    if (command == BN_CLICKED)
    {
      int i = ListBox_GetCurSel(hwnd_list);
      if (i == LB_ERR)
	i = 0;
      
	  /* "handle@hostname:port" ł͂ȂAݕҏW̓eǉ */
	  //ListBox_InsertString(hwnd_list, i, new_list_string);
	  char edittext[1024];
	  GetEditText(edittext, sizeof(edittext)-1);
      ListBox_InsertString(hwnd_list, i, edittext);

	  ListBox_SetCurSel(hwnd_list, i);
      sel_changed(TRUE);
      PropertySheetChanged();
    }
    return TRUE;
  }
  
  BOOL wmCommand_ButtonDelete(void)
  {
    if (command == BN_CLICKED)
    {
      int i = ListBox_GetCurSel(hwnd_list);
      if (i != LB_ERR)
      {
	ListBox_DeleteString(hwnd_list, i);
	ListBox_SetCurSel(hwnd_list, i);
	//redraw(rButtonChooseColor);
	sel_changed(TRUE);
	PropertySheetChanged();
      }
    }
    return TRUE;
  }
  
  BOOL wmCommand_ButtonUp(void)
  {
    if (command == BN_CLICKED)
    {
      int i = ListBox_GetCurSel(hwnd_list);
      if (i != LB_ERR && 0 < i)
      {
	char buf[BUFSIZE];
	ListBox_GetText(hwnd_list, i, buf);
	ListBox_DeleteString(hwnd_list, i);
	ListBox_InsertString(hwnd_list, i - 1, buf);
	ListBox_SetCurSel(hwnd_list, i - 1);
	sel_changed(TRUE);
	PropertySheetChanged();
      }
    }
    return TRUE;
  }
  
  BOOL wmCommand_ButtonDown(void)
  {
    if (command == BN_CLICKED)
    {
      int i = ListBox_GetCurSel(hwnd_list);
      if (i != LB_ERR && i < ListBox_GetCount(hwnd_list) - 1)
      {
	char buf[BUFSIZE];
	ListBox_GetText(hwnd_list, i, buf);
	ListBox_DeleteString(hwnd_list, i);
	ListBox_InsertString(hwnd_list, i + 1, buf);
	ListBox_SetCurSel(hwnd_list, i + 1);
	sel_changed(TRUE);
	PropertySheetChanged();
      }
    }
    return TRUE;
  }
};
