/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogParanoia1.cxx


#include	<winsock2.h>
#include "Dialog.h"
#include "lgDialog.h"
#include "lgFiles.h"
#include "witalk2.h"
#include "ProfileManager.h"
#include "WinDLL.h"

#include "DialogParanoia1.h"
#include "TimerQueue.h"

extern	WItalk2* witalk2_ptr;
extern	char iniFileName[BUFSIZE];

extern	HWND	firstWindow;


 
// WM_INITDIALOG
BOOL DialogParanoia1::wmInitDialog(HWND /* focus */, LPARAM  lParam )
{
	if( lParam ){
		PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
		m_pProfileManager = (ProfileManager*)pProp->lParam;
	}
	_ASSERT( m_pProfileManager != NULL );

	int		value;
		
	// eobt@̐\ ShowTip rCommandOtherShowTip rCheckBufferTooltip
	m_pProfileManager->Read("ShowTip", value, false);
	Button_SetCheck(Hwnd(rCheckBufferTooltip), value);

	// fobOpGR[obN (DebugEchoback) rCommandOtherEcho rCheckDebugEchoback
	m_pProfileManager->Read("DebugEchoback", value, false);
	Button_SetCheck(Hwnd(rCheckDebugEchoback), value);

	// u[Uv\ ShowWA rCommandLogShowWa rCheckNohideWA
	m_pProfileManager->Read("ShowWA", value, false);
	Button_SetCheck(Hwnd(rCheckNohideWA), value);

	// uOEBhEvɕ\ OutputToLog rCommandLogOutputToLog rCheckAllLogWindow
	value = false; //m_pProfileManager->Read("OutputToLog", value, false);
	Button_SetCheck(Hwnd(rCheckAllLogWindow), value);

	// ud̂݃EBhEvɕ\ OutputToPrivateLog rCommandLogOutputToPrivateLog rCheckTelegramWindow
	value = true; //m_pProfileManager->Read("OutputToPrivateLog", value, true);
	Button_SetCheck(Hwnd(rCheckTelegramWindow), value);

	// udȊOEBhEvɕ\ OutputToPublicLog rCommandLogOutputToPublicLog rCheckNotTelegramWindow
	value = true; //m_pProfileManager->Read("OutputToPublicLog", value, true);
	Button_SetCheck(Hwnd(rCheckNotTelegramWindow), value);

	// SSL on/off ݒ
	m_pProfileManager->Read("EnableSSLSwitching", value, true);
	Button_SetCheck(Hwnd(rCheckEnableSSLConnection), value);

	// /x nop ݒ
	m_pProfileManager->Read("EnableXnop", value, true);
	Button_SetCheck(Hwnd(rCheckEnableXnop), value);
	m_pProfileManager->Read("XnopInterval", value, 50);
	if (value < 10 || value > 86400) value = 50;
	SetWindowText(Hwnd(rEditXnopInterval), value);

	set_all();
	return TRUE;
}

// OK ͍XV
BOOL DialogParanoia1::wmNotify_psnApply (void)
{
	// eobt@̐\ ShowTip rCommandOtherShowTip rCheckBufferTooltip
	m_pProfileManager->Write("ShowTip", paranoia1_showtip = Button_GetCheck(Hwnd(rCheckBufferTooltip)));

	// fobOpGR[obN (DebugEchoback) rCommandOtherEcho rCheckDebugEchoback
	m_pProfileManager->Write("DebugEchoback", paranoia1_debugechoback = Button_GetCheck(Hwnd(rCheckDebugEchoback)));

	// u[Uv\ ShowWA rCommandLogShowWa rCheckNohideWA
	m_pProfileManager->Write("ShowWA", paranoia1_showwa = Button_GetCheck(Hwnd(rCheckNohideWA)));

#if 0
	// uOEBhEvɕ\ OutputToLog rCommandLogOutputToLog rCheckAllLogWindow
	m_pProfileManager->Write("OutputToLog", paranoia1_outputtolog = Button_GetCheck(Hwnd(rCheckAllLogWindow)));

	// ud̂݃EBhEvɕ\ OutputToPrivateLog rCommandLogOutputToPrivateLog rCheckTelegramWindow
	m_pProfileManager->Write("OutputToPrivateLog", paranoia1_outputtoprivatelog = Button_GetCheck(Hwnd(rCheckTelegramWindow)));

	// udȊOEBhEvɕ\ OutputToPublicLog rCommandLogOutputToPublicLog rCheckNotTelegramWindow
	m_pProfileManager->Write("OutputToPublicLog", paranoia1_outputtopubliclog = Button_GetCheck(Hwnd(rCheckNotTelegramWindow)));
#endif

	// SSL on/off ݒ
	m_pProfileManager->Write("EnableSSLSwitching", paranoia1_sslswitching = Button_GetCheck(Hwnd(rCheckEnableSSLConnection)));

	// /x nop ݒ
	{
		int		_paranoia1_xnop = Button_GetCheck(Hwnd(rCheckEnableXnop));
		char buf[BUFSIZE];
	    GetWindowText(rEditXnopInterval, buf, sizeof(buf));
		int		_paranoia1_xnop_interval = atoi(buf);
		if (_paranoia1_xnop_interval < 10) _paranoia1_xnop_interval = 10;
		if (_paranoia1_xnop_interval > 86400) _paranoia1_xnop_interval = 86400;

		if (_paranoia1_xnop && !paranoia1_xnop) {
			if (witalk2_ptr->ic.IsConnecting()) wi_timer_q->start(1, 1, _paranoia1_xnop_interval*1000, nullptr);
		} else if (!_paranoia1_xnop && paranoia1_xnop) {
			wi_timer_q->cancel(1, 1);
		} else if (_paranoia1_xnop && paranoia1_xnop && _paranoia1_xnop_interval != paranoia1_xnop_interval) {
			if (witalk2_ptr->ic.IsConnecting()) wi_timer_q->restart(1, 1, _paranoia1_xnop_interval*1000);
		}
		m_pProfileManager->Write("EnableXnop", paranoia1_xnop = _paranoia1_xnop);
		m_pProfileManager->Write("XnopInterval", paranoia1_xnop_interval = _paranoia1_xnop_interval);
	}

	witalk2_ptr->set_tooltip();

	SendMessage(HwndPropertySheetOwner(), WM_DIALOGNOTIFY, rDialogOther, TRUE);
	return lgDialog::wmNotify_psnApply();
}
	
// WM_COMMAND
BOOL DialogParanoia1::wmCommand (int notify_code, int id, HWND /* hwnd_control */)
{
	switch (id)
	{
#define c(x) case r##x: return wmCommand_##x(notify_code)
#define d(x) case r##x: return wmCommand_common(notify_code)
		d(CheckBufferTooltip);
		d(CheckDebugEchoback);
		d(CheckNohideWA);
		d(CheckAllLogWindow);
		d(CheckNotTelegramWindow);
		d(CheckTelegramWindow);
#undef c
#undef d
	}
	return TRUE;
}

// L
BOOL DialogParanoia1::wmCommand_common (int command)
{
	PropertySheetChanged(); set_all(); return TRUE;
}

int		DialogParanoia1::paranoia1_showtip = false;
int		DialogParanoia1::paranoia1_debugechoback = false;
int		DialogParanoia1::paranoia1_showwa = false;
int		DialogParanoia1::paranoia1_outputtolog = false;
int		DialogParanoia1::paranoia1_outputtoprivatelog = true;
int		DialogParanoia1::paranoia1_outputtopubliclog = true;
int		DialogParanoia1::paranoia1_sslswitching = true;
int		DialogParanoia1::paranoia1_xnop = true;
int		DialogParanoia1::paranoia1_xnop_interval = 50;


BOOL CALLBACK DialogParanoia1DlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogParanoia1
	if (!lgwc) switch (message) {
		lgwmInitDialog;
	} else switch (message) {
		lgwmCommand;
    }
	return lgwc->Default(message, wParam, lParam, TRUE);
}
