/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogUsers.cxx


#include	<winsock2.h>
#include	<crtdbg.h>
#include	<time.h>
#include	<math.h>
#include	<process.h>
#include	<shlobj.h> 

#include	"Dialog.h"
#include	"lgDialog.h"
#include	"TelegramWindow.h"
#include	"WItalk2.h"
#include	"ProfileManager.h"
#include	"WinDLL.h"
#include	"TrapFocus.h"
#include	"ItalkInfo.h"
#include	"Trace.h"


#define TOOLBAR_MAGIC_NUMBER 2

void*	usersDialogPtr;					// Waffle 0.2.0pre-0: g̃CX^Xւ̃|C^
int		selectedIndex;					// Waffle 0.2.0pre-0: ݑIĂ index (-1: G[)

extern	HINSTANCE	hinstance;
extern	void setPeerTelegramWindowTitle(HWND hwnd, ItalkInfo::User* user);

extern	HWND	usersWindow;
HWND	usersWindow;

extern	int window_transparency;
extern	bool does_window_transparent, does_users_window_transparent, does_telegram_window_transparent;

class PeerTelegramWindowClass{
public:
	WNDCLASSEX	wcTelegram, wcSubroom;
	bool		wcRegistered;

	char* classnameTelegram(){ return "PeerTelegramWindowClass"; }
	char* classnameSubroom(){ return "SubroomWindowClass"; }
	PeerTelegramWindowClass(){ wcRegistered = false; }
	void registerclass(){
		char	classnameTelegram[] = "PeerTelegramWindowClass";
		wcTelegram.cbSize = sizeof(wcTelegram);		/* 񑩊Jn */
		wcTelegram.style = CS_HREDRAW | CS_VREDRAW;
		wcTelegram.lpfnWndProc = TelegramWndProc;
		wcTelegram.hInstance = hinstance;
		wcTelegram.hCursor = LoadCursor(0, IDC_ARROW);
		wcTelegram.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
		wcTelegram.lpszMenuName = 0;
		wcTelegram.lpszClassName = classnameTelegram;
		wcTelegram.hIcon = LoadIcon(hinstance, MAKEINTRESOURCE(rIconWItalk2Telegram));
		wcTelegram.hIconSm = LoadIcon(hinstance, MAKEINTRESOURCE(rWItalk2TelegramSm));
		wcTelegram.cbClsExtra = wcTelegram.cbWndExtra = sizeof(int);	/* TLS */
		ATOM rrcex = RegisterClassEx(&wcTelegram);
		_ASSERT(rrcex);
		char	classnameSubroom[] = "SubroomWindowClass";
		wcSubroom.cbSize = sizeof(wcSubroom);		/* 񑩊Jn */
		wcSubroom.style = CS_HREDRAW | CS_VREDRAW;
		wcSubroom.lpfnWndProc = TelegramWndProc;
		wcSubroom.hInstance = hinstance;
		wcSubroom.hCursor = LoadCursor(0, IDC_ARROW);
		wcSubroom.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
		wcSubroom.lpszMenuName = 0;
		wcSubroom.lpszClassName = classnameSubroom;
		wcSubroom.hIcon = LoadIcon(hinstance, MAKEINTRESOURCE(rIconWItalk2Subroom));
		wcSubroom.hIconSm = LoadIcon(hinstance, MAKEINTRESOURCE(rIconWItalk2SubroomSm));
		wcSubroom.cbClsExtra = wcSubroom.cbWndExtra = sizeof(int);	/* TLS */
		rrcex = RegisterClassEx(&wcSubroom);
		_ASSERT(rrcex);
		wcRegistered = true;
	}
} peerwc;

class FileTransferInfo{
public:
	char*	hostname;					// ڑzXg
	char*	handle;						// ڑnh
	int		userno;						// ڑ胆[UNo.
	FileTransferInfo(){
		hostname = new char[1024]; handle = new char[1024];
	}
	~FileTransferInfo(){
		delete [] hostname; delete [] handle;
	}
};

class FileSendInfo{
public:
	char*	handle;						// M̐l̃nh
	int		userno;						// M̐l̃[UNo.

	char*	filename;					// Mt@C
	int		connectMode;				// ڑ
	int		usePort80;					// \Ȃ 80 ԃ|[ggp邩
	int		useProxy;					// Proxy gp邩
	char*	proxyHost;					// Proxy zXg
	int		proxyPort;					// Proxy |[gԍ

	FileSendInfo(){
		handle = filename = proxyHost = 0;
	}
	~FileSendInfo(){
		if (proxyHost != 0) delete [] proxyHost;
		if (filename != 0) delete [] filename;
		if (handle != 0) delete [] handle;
	}
};

class FileReceiveInfo{
public:
	char*	dirname;					// MfBNg
	int		connectMode;				// ڑ
	int		usePort80;					// \Ȃ 80 ԃ|[ggp邩
	int		useProxy;					// Proxy gp邩
	char*	proxyHost;					// Proxy zXg
	int		proxyPort;					// Proxy |[gԍ
	int		overwriteMode;				// dt@C̈

	FileReceiveInfo(){
		dirname = proxyHost = 0;
	}

	~FileReceiveInfo(){
		if (dirname != 0) delete [] dirname;
		if (proxyHost != 0) delete [] proxyHost;
	}
};

FileTransferInfo*	lastInfo;			// X댯

// tH_I_CAOoătH_I 
//   ̂ւꎮ "VC++ɂWin32vO~OTips" Ql (http://www.expertmg.com/html/cti/vctips/)
bool GetOpenFolderName(HWND hwnd, LPCSTR lpszTitle, LPCSTR lpszBuffer, DWORD dwBufferSize)
{
	BROWSEINFO	bi;
	ITEMIDLIST*	pidl;
	char		szSelectedFolder[MAX_PATH];

	memset((void*)&bi, 0, sizeof(bi));
	bi.hwndOwner = hwnd;
	bi.lpszTitle = lpszTitle;
	pidl = SHBrowseForFolder(&bi);
	bi.ulFlags |= BIF_RETURNONLYFSDIRS;
	if (pidl){
		//  IꂽtH_擾
		SHGetPathFromIDList( pidl, szSelectedFolder );
		if (lstrlen(szSelectedFolder) == 0) return false;
		if((DWORD)lstrlen(szSelectedFolder) < dwBufferSize) lstrcpy((LPSTR)lpszBuffer, szSelectedFolder);
        //  tH_Iꂽ
        return IDOK;
	}
	return false;
}

// t@CMݒ_CAȌԐ
void adjustSendFileDialog(HWND hDlg)
{
	/* ڑ PASV Ȃu|[ggpv GRAY  */
	if (IsDlgButtonChecked(hDlg, rFileSendConnectPassive) == BST_CHECKED) EnableWindow(GetDlgItem(hDlg, rFileSendUsePort80), false); else EnableWindow(GetDlgItem(hDlg, rFileSendUsePort80), true);
	/* ڑ Active Ȃ Proxy ͂gpȂ */
	if (IsDlgButtonChecked(hDlg, rFileSendConnectActive) == BST_CHECKED){
		EnableWindow(GetDlgItem(hDlg, rFileSendUseProxy), false); EnableWindow(GetDlgItem(hDlg, rFileSendProxyHost), false); EnableWindow(GetDlgItem(hDlg, rFileSendProxyPort), false);
	} else {
		EnableWindow(GetDlgItem(hDlg, rFileSendUseProxy), true );
		if (IsDlgButtonChecked(hDlg, rFileSendUseProxy) == BST_CHECKED){
			EnableWindow(GetDlgItem(hDlg, rFileSendProxyHost), true ); EnableWindow(GetDlgItem(hDlg, rFileSendProxyPort), true );
		} else {
			EnableWindow(GetDlgItem(hDlg, rFileSendProxyHost), false); EnableWindow(GetDlgItem(hDlg, rFileSendProxyPort), false);
		}
	}
}

// t@CMݒ_CAȌԐ
void adjustReceiveFileDialog(HWND hDlg)
{
	/* ڑ PASV Ȃu|[ggpv GRAY  */
	if (IsDlgButtonChecked(hDlg, rFileReceiveConnectPassive) == BST_CHECKED) EnableWindow(GetDlgItem(hDlg, rFileReceiveUsePort80), false); else EnableWindow(GetDlgItem(hDlg, rFileReceiveUsePort80), true);
	/* ڑ Active Ȃ Proxy ͂gpȂ */
	if (IsDlgButtonChecked(hDlg, rFileReceiveConnectActive) == BST_CHECKED){
		EnableWindow(GetDlgItem(hDlg, rFileReceiveUseProxy), false); EnableWindow(GetDlgItem(hDlg, rFileReceiveProxyHost), false); EnableWindow(GetDlgItem(hDlg, rFileSendProxyPort), false);
	} else {
		EnableWindow(GetDlgItem(hDlg, rFileReceiveUseProxy), true );
		if (IsDlgButtonChecked(hDlg, rFileReceiveUseProxy) == BST_CHECKED){
			EnableWindow(GetDlgItem(hDlg, rFileReceiveProxyHost), true ); EnableWindow(GetDlgItem(hDlg, rFileReceiveProxyPort), true );
		} else {
			EnableWindow(GetDlgItem(hDlg, rFileReceiveProxyHost), false); EnableWindow(GetDlgItem(hDlg, rFileReceiveProxyPort), false);
		}
	}
}

// t@CMݒ_CAÕftHglۑ
FileSendInfo* writeRegistrySendFileDialog(HWND hDlg)
{
	FileSendInfo*	fsi = new FileSendInfo();
	//lgRegistry	reg(REGISTRY_ROOT);
	ProfileManager* pManager = witalk2_ptr->getProfileManager();
	/* ftHg̐ڑۑ */
	int		connectMethod;
	if (IsDlgButtonChecked(hDlg, rFileSendConnectActive) == BST_CHECKED) connectMethod = 0;
	if (IsDlgButtonChecked(hDlg, rFileSendConnectPassive) == BST_CHECKED) connectMethod = 1;
	if (IsDlgButtonChecked(hDlg, rFileSendConnectNormal) == BST_CHECKED) connectMethod = 2;
	pManager->Write("SendFileConnectMethod", connectMethod);
	fsi->connectMode = connectMethod;
	/* ftHg̓|[ggpۑ */
	int		usePort80;
	usePort80 = (IsDlgButtonChecked(hDlg, rFileSendUsePort80) == BST_CHECKED);
	pManager->Write("SendFileUsePort80", usePort80);
	fsi->usePort80 = usePort80;
	/* ftHg Proxy gpۑ */
	int		useProxy;
	useProxy = (IsDlgButtonChecked(hDlg, rFileSendUseProxy) == BST_CHECKED);
	pManager->Write("SendFileUseProxy", useProxy);
	fsi->useProxy = useProxy;
	/* ftHg Proxy zXgۑ */
	char*	proxyHost = new char[1024];
	GetWindowText(GetDlgItem(hDlg, rFileSendProxyHost), proxyHost, 1024);
	pManager->Write("SendFileProxyHost", proxyHost);
	fsi->proxyHost = proxyHost;
	/* ftHg Proxy |[gԍۑ */
	int		proxyPort;
	char	proxyPortStr[1024];
	GetWindowText(GetDlgItem(hDlg, rFileSendProxyPort), proxyPortStr, sizeof(proxyPortStr));
	proxyPort = atol(proxyPortStr);
	pManager->Write("SendFileProxyPort", proxyPort);
	fsi->proxyPort = proxyPort;
	/* TLS (t@CIe) */
	char	TLS[1024];
	GetWindowText(GetDlgItem(hDlg, rSendFileTLS), TLS, sizeof(TLS));
	fsi->filename = (char*)atol(TLS);
	return fsi;
}

// t@CMݒ_CAÕftHglۑ
FileReceiveInfo* writeRegistryReceiveFileDialog(HWND hDlg)
{
	FileReceiveInfo*	fri = new FileReceiveInfo();
	//lgRegistry	reg(REGISTRY_ROOT);
	ProfileManager* pManager = witalk2_ptr->getProfileManager();
	/* dt@C̈ۑ */
	int		overwriteMethod;
	if (IsDlgButtonChecked(hDlg, rFileReceiveFileResume) == BST_CHECKED) overwriteMethod = 0;
	if (IsDlgButtonChecked(hDlg, rFileReceiveFileOverwrite) == BST_CHECKED) overwriteMethod = 1;
	if (IsDlgButtonChecked(hDlg, rFileReceiveFileRename) == BST_CHECKED) overwriteMethod = 2;
	pManager->Write("ReceiveFileOverwriteMethod", overwriteMethod);
	fri->overwriteMode = overwriteMethod;
	/* ftHg̐ڑۑ */
	int		connectMethod;
	if (IsDlgButtonChecked(hDlg, rFileReceiveConnectActive) == BST_CHECKED) connectMethod = 0;
	if (IsDlgButtonChecked(hDlg, rFileReceiveConnectPassive) == BST_CHECKED) connectMethod = 1;
	if (IsDlgButtonChecked(hDlg, rFileReceiveConnectNormal) == BST_CHECKED) connectMethod = 2;
	pManager->Write("ReceiveFileConnectMethod", connectMethod);
	fri->connectMode = connectMethod;
	/* ftHg̓|[ggpۑ */
	int		usePort80;
	usePort80 = (IsDlgButtonChecked(hDlg, rFileReceiveUsePort80) == BST_CHECKED);
	pManager->Write("ReceiveFileUsePort80", usePort80);
	fri->usePort80 = usePort80;
	/* ftHg Proxy gpۑ */
	int		useProxy;
	useProxy = (IsDlgButtonChecked(hDlg, rFileReceiveUseProxy) == BST_CHECKED);
	pManager->Write("ReceiveFileUseProxy", useProxy);
	fri->useProxy = useProxy;
	/* ftHg Proxy zXgۑ */
	char*	proxyHost = new char[1024];
	GetWindowText(GetDlgItem(hDlg, rFileReceiveProxyHost), proxyHost, 1024);
	pManager->Write("ReceiveFileProxyHost", proxyHost);
	fri->proxyHost = proxyHost;
	/* ftHg Proxy |[gԍۑ */
	int		proxyPort;
	char	proxyPortStr[1024];
	GetWindowText(GetDlgItem(hDlg, rFileReceiveProxyPort), proxyPortStr, sizeof(proxyPortStr));
	proxyPort = atol(proxyPortStr);
	pManager->Write("ReceiveFileProxyPort", proxyPort);
	fri->proxyPort = proxyPort;
	/* TLS (fBNgIe) */
	char	TLS[1024];
	GetWindowText(GetDlgItem(hDlg, rReceiveFileTLS), TLS, sizeof(TLS));
	fri->dirname = (char*)atol(TLS);
	return fri;
}

// t@CMXbhŎgp_CAOvV[W
BOOL CALLBACK SendFileDialogProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg){
	// _CAO
	case WM_INITDIALOG:
		/* X댯ł邪AŃO[oϐoRēnꂽnh userno gp */
		{
			char	sendtostatic[1024];
			sprintf(sendtostatic, "Send To: %s(%d)", lastInfo->handle, lastInfo->userno);
			SetWindowText(GetDlgItem(hDlg, rFileSendStaticConnectPartner), sendtostatic);
		}
		/* WXg珉l擾Đݒ */
		{
			//lgRegistry	reg(REGISTRY_ROOT);
			ProfileManager* pManager = witalk2_ptr->getProfileManager();
			/* ڑ */
			int		connectMethod;
			pManager->Read("SendFileConnectMethod", connectMethod, 2);
			CheckRadioButton(hDlg, rFileSendConnectActive, rFileSendConnectNormal, rFileSendConnectActive+connectMethod);
			/* Port80 gp */
			int		usePort80;
			pManager->Read("SendFileUsePort80", usePort80, true);
			CheckDlgButton(hDlg, rFileSendUsePort80, usePort80);
			/* Proxy gp */
			int		useProxy;
			pManager->Read("SendFileUseProxy", useProxy, false);
			CheckDlgButton(hDlg, rFileSendUseProxy, useProxy);
			/* Proxy zXg */
			char	proxyHost[1024];
			pManager->Read("SendFileProxyHost", proxyHost, sizeof(proxyHost), "wwwcache.nc.u-tokyo.ac.jp");
			SetWindowText(GetDlgItem(hDlg, rFileSendProxyHost), proxyHost);
			/* Proxy |[g */
			int		proxyPort;
			pManager->Read("SendFileProxyPort", proxyPort, 8080);
			char	proxyPortString[16];
			sprintf(proxyPortString, "%d", proxyPort);
			SetWindowText(GetDlgItem(hDlg, rFileSendProxyPort), proxyPortString);
			/* TLS */
			SetWindowText(GetDlgItem(hDlg, rSendFileTLS), "0");
			/* t@CꗗGfBbgRg[ GRAYED */
			EnableWindow(GetDlgItem(hDlg, rFileSendFilename), false);
		}
		/* _CAO󋵂 Adjust */
		adjustSendFileDialog(hDlg);
		return TRUE;
	case WM_COMMAND:
		adjustSendFileDialog(hDlg);
		switch(LOWORD(wParam)){
		case rFileSendFileReference:
			{
				OPENFILENAME	ofn;
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hDlg; ofn.hInstance = NULL; ofn.lpstrCustomFilter = NULL; ofn.nMaxCustFilter = 0;
				ofn.lpstrTitle = "Mt@C";
				ofn.lCustData = 0L; ofn.lpfnHook = NULL; ofn.lpTemplateName = NULL;
				ofn.lpstrInitialDir = NULL; ofn.nFileOffset = 0; ofn.nFileExtension = 0;
				ofn.Flags = OFN_ALLOWMULTISELECT | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_LONGNAMES | OFN_NODEREFERENCELINKS;
				ofn.lpstrFilter = "SẴt@C (*.*)\0*.*\0" "摜t@C (GIF/JPG/PNG/BMP/PS)\0*.gif;*.jpg;*.bmp;*.png;*.ps\0" \
								  "Ƀt@C (LZH/ZIP/GZ/TAR/TGZ)\0*.lzh;*.zip;*.gz;*.tar;*.tgz\0" "eLXgt@C (TXT)\0*.txt\0" \
								  "t@C (WAV/MP3/MP2)\0*.wav;*.mp3;*.mp2\0" "t@C (MPG/AVI)\0*.mpg;*.avi\0";
				ofn.lpstrDefExt = "txt";
				ofn.nMaxFile = 32767;
				ofn.lpstrFile = new char[ofn.nMaxFile + 1]; memset(ofn.lpstrFile, 0, ofn.nMaxFile + 1);
				ofn.lpstrFileTitle = 0;
				ofn.lpstrFile[0] = 0;
				if (!GetOpenFileName(&ofn)){
//					MessageBox(0, "It@C܂", "G[", MB_OK);		// LZ
				} else {
					/* ̑It@Cւ̃|C^̒l𕶎ϊ static Rg[ɃZbg (TLS) */
					char*	toTLS = new char[ofn.nMaxFile + 1];
					memcpy(toTLS, ofn.lpstrFile, ofn.nMaxFile + 1);
					char	oldSelectedFiles[1024];
					GetWindowText(GetDlgItem(hDlg, rSendFileTLS), oldSelectedFiles, sizeof(oldSelectedFiles));
					char*	oldSelectedFilesPtr = (char*)atol(oldSelectedFiles);
					if (oldSelectedFilesPtr != 0) delete [] oldSelectedFilesPtr;	/* It@C̃̈ */
					sprintf(oldSelectedFiles, "%d", toTLS);
					SetWindowText(GetDlgItem(hDlg, rSendFileTLS), oldSelectedFiles);	/* VIt@C̃̈ւ̃|C^Zbg */
					for (char* p = ofn.lpstrFile; *p != 0 || *(p+1) != 0; p++) if (*p == 0) *p = 0x20;
					SetWindowText(GetDlgItem(hDlg, rFileSendFilename), ofn.lpstrFile);
				}
				delete [] ofn.lpstrFile;
			}
			return TRUE;
		case IDOK:
			/* I󋵓WXgɋL^ */
			{
				/* t@CIĂȂΖ߂Ȃ */
				{
					char	selected[1024];
					GetWindowText(GetDlgItem(hDlg, rSendFileTLS), selected, sizeof(selected));
					if (atol(selected) == 0){
						MessageBox(0, "Mt@CIĂ܂B", "G[", MB_OK);
						return TRUE;
					}
				}
				FileSendInfo* fsi = writeRegistrySendFileDialog(hDlg);
				EndDialog(hDlg, (int)(void*)fsi);
				return TRUE;
			}
		case IDCANCEL:
			/* TLS  */
			{
				char	TLS[1024];
				GetWindowText(GetDlgItem(hDlg, rSendFileTLS), TLS, sizeof(TLS));
				char*	TLSptr = (char*)atol(TLS);
				if (TLSptr != 0) delete [] TLSptr;
			}
			EndDialog(hDlg, 0);
			return TRUE;
		}
	default:
		return FALSE;
	}
}

// t@CMݒ_CAOvV[W
BOOL CALLBACK ReceiveFileDialogProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg){
	// _CAO
	case WM_INITDIALOG:
		/* X댯ł邪AŃO[oϐoRēnꂽnh userno gp */
		{
			char	receivefromstatic[1024];
			sprintf(receivefromstatic, "Receive From: %s(%d)", lastInfo->handle, lastInfo->userno);
			SetWindowText(GetDlgItem(hDlg, rFileReceiveStaticConnectPartner), receivefromstatic);
		}
		/* WXg珉l擾Đݒ */
		{
			//lgRegistry	reg(REGISTRY_ROOT);
			ProfileManager* pManager = witalk2_ptr->getProfileManager();
			/* dt@C̈ */
			int		overwriteMethod;
			pManager->Read("ReceiveFileOverwriteMethod", overwriteMethod, 1);
			CheckRadioButton(hDlg, rFileReceiveFileResume, rFileReceiveFileOverwrite, rFileReceiveFileResume + overwriteMethod);
			/* dt@C̈́u㏑vŌŒ */
			EnableWindow(GetDlgItem(hDlg, rFileReceiveFileResume), false);
			EnableWindow(GetDlgItem(hDlg, rFileReceiveFileOverwrite), false);
			EnableWindow(GetDlgItem(hDlg, rFileReceiveFileRename), false);
			EnableWindow(GetDlgItem(hDlg, rFileReceiveOverwriteMethod), false);
			/* ڑ */
			int		connectMethod;
			pManager->Read("ReceiveFileConnectMethod", connectMethod, 2);
			CheckRadioButton(hDlg, rFileReceiveConnectActive, rFileReceiveConnectNormal, rFileReceiveConnectActive+connectMethod);
			/* Port80 gp */
			int		usePort80;
			pManager->Read("ReceiveFileUsePort80", usePort80, true);
			CheckDlgButton(hDlg, rFileReceiveUsePort80, usePort80);
			/* Proxy gp */
			int		useProxy;
			pManager->Read("ReceiveFileUseProxy", useProxy, false);
			CheckDlgButton(hDlg, rFileReceiveUseProxy, useProxy);
			/* Proxy zXg */
			char	proxyHost[1024];
			pManager->Read("ReceiveFileProxyHost", proxyHost, sizeof(proxyHost), "wwwcache.nc.u-tokyo.ac.jp");
			SetWindowText(GetDlgItem(hDlg, rFileReceiveProxyHost), proxyHost);
			/* Proxy |[g */
			int		proxyPort;
			pManager->Read("ReceiveFileProxyPort", proxyPort, 8080);
			char	proxyPortString[16];
			sprintf(proxyPortString, "%d", proxyPort);
			SetWindowText(GetDlgItem(hDlg, rFileReceiveProxyPort), proxyPortString);
			/* TLS */
			SetWindowText(GetDlgItem(hDlg, rReceiveFileTLS), "0");
			/* fBNgGfBbgRg[ GRAYED */
			EnableWindow(GetDlgItem(hDlg, rFileReceiveDirectory), false);
		}
		/* _CAO󋵂 Adjust */
		adjustReceiveFileDialog(hDlg);
		return TRUE;
	case WM_COMMAND:
		adjustReceiveFileDialog(hDlg);
		switch(LOWORD(wParam)){
		case rFileReceiveFileReference:
			{
				char*	dirname = new char[MAX_PATH];
				if (GetOpenFolderName(hDlg, "_E[hfBNg", dirname, MAX_PATH)){
					// TLS ɕۑ
					char	TLS[1024];
					GetWindowText(GetDlgItem(hDlg, rReceiveFileTLS), TLS, sizeof(TLS));
					if (atol(TLS) != 0) delete [] (char*)atol(TLS);
					sprintf(TLS, "%d", dirname);
					SetWindowText(GetDlgItem(hDlg, rReceiveFileTLS), TLS);
					SetWindowText(GetDlgItem(hDlg, rFileReceiveDirectory), dirname);
				} else {
					delete [] dirname;
				}
			}
			return TRUE;
		case IDOK:
			/* I󋵓WXgɋL^ */
			{
				/* fBNgIĂȂΖ߂Ȃ */
				{
					char	selected[1024];
					GetWindowText(GetDlgItem(hDlg, rReceiveFileTLS), selected, sizeof(selected));
					if (atol(selected) == 0){
						MessageBox(0, "MfBNgIĂ܂B", "G[", MB_OK);
						return TRUE;
					}
				}
				FileReceiveInfo* fri = writeRegistryReceiveFileDialog(hDlg);
				EndDialog(hDlg, (int)(void*)fri);
				return TRUE;
			}
		case IDCANCEL:
			/* TLS  */
			{
				char	TLS[1024];
				GetWindowText(GetDlgItem(hDlg, rReceiveFileTLS), TLS, sizeof(TLS));
				char*	TLSptr = (char*)atol(TLS);
				if (TLSptr != 0) delete [] TLSptr;
			}
			EndDialog(hDlg, 0);
			return TRUE;
		}
	default:
		return FALSE;
	}
}

// t@CM
void SendFile(FileTransferInfo* fti, FileSendInfo* fsi)
{
#if 0
	/* t@C */
	int		files = 1;
	char	basedir[MAX_PATH];
	char*	filelist;
	{ for (char* p = fsi->filename; *p != 0 && *(p+1) != 0; p++) if (*p == 0) files++; }
	if (files == 1){
		/* t@C 1 ȂtpX̂͂ */
		basedir[0] = 0; filelist = fsi->filename;
	} else {
		strcpy(basedir, fsi->filename);
		for (char* p = fsi->filename; *p != 0; p++) ;
		filelist = p+1;
		/* fBNg "\"  */
		if (basedir[strlen(basedir)-1] != 0x5C) strcat(basedir, "\x5C");
	}
	/* nhVFCNJn */
	;
#endif
}

// t@CM
void ReceiveFile(FileTransferInfo* fti, FileReceiveInfo* fri)
{
	;
}

#if 0
// t@CMXbh
void _cdecl SendFileThread(void* fti_)	
{
	FileTransferInfo*	fti = (FileTransferInfo*)fti_;
	lastInfo = fti;
	FileSendInfo*		fsi = (FileSendInfo*)DialogBox((HINSTANCE)GetWindowLongPtr(witalk2_ptr->Hwnd(), GWL_HINSTANCE), MAKEINTRESOURCE(rDialogSendFile), masterHwnd, SendFileDialogProc);
	if (fsi != 0) SendFile(fti, fsi);
	delete fti; if (fsi != 0) delete fsi;
	_endthread();
}
#endif

#if 0
// t@CMXbh
void _cdecl ReceiveFileThread(void* fti_)
{
	FileTransferInfo*	fti = (FileTransferInfo*)fti_;
	lastInfo = fti;
	FileReceiveInfo*	fri = (FileReceiveInfo*)DialogBox((HINSTANCE)GetWindowLongPtr(witalk2_ptr->Hwnd(), GWL_HINSTANCE), MAKEINTRESOURCE(rDialogReceiveFile), masterHwnd, ReceiveFileDialogProc);
	if (fri != 0) ReceiveFile(fti, fri);
	delete fti; if (fri != 0) delete fri;
	_endthread();
}
#endif

// Waffle 0.2.0: ʓdEBhEJ
void wmCommandUserTelegram(LPARAM notify_code)
{
	ItalkInfo::User* user = NULL;
	user = witalk2_ptr->italk_info.GetUserFromIndex(selectedIndex);
	int		userno = 0;
	if (user == NULL){
		if (selectedIndex >= 9900) {	// inid quickhack thread
			userno = selectedIndex;
		} else {
			MessageBox(0, "[U̎擾Ɏs܂B", "G[", MB_OK); return;
		}
	} else {
		userno = user->userno;
	}
	// ɊJĂȂA ShowWindow() 邾ɂ */
	HWND prevhwnd = witalk2_ptr->SearchTelegramDeliveryTable(userno);
	if (prevhwnd != 0){
		// EBhEX^C WS_EX_TOOLWINDOW  WS_EX_APPWINDOW ɕύX
		SetWindowLongPtr(prevhwnd, GWL_EXSTYLE, (GetWindowLongPtr(prevhwnd, GWL_EXSTYLE) | WS_EX_APPWINDOW) & (~WS_EX_TOOLWINDOW));
		ShowWindow(prevhwnd, SW_RESTORE); return;
	}
	// IWi WItalk2 EBhẼTCY擾
	int		witalkWidth = witalk2_ptr->mainWindowWidth, witalkHeight = witalk2_ptr->mainWindowHeight;
	// EBhENXo^ĂȂΓo^
	if (!peerwc.wcRegistered) peerwc.registerclass();
	// ʓdEBhEJ
	/* WXgɈʒuETCYۑĂΓǂݏo */
	ProfileManager* pManager = witalk2_ptr->getProfileManager();
	RECT	xrc;
	xrc.top = CW_USEDEFAULT; xrc.left = CW_USEDEFAULT; xrc.bottom = witalkHeight/2; xrc.right = witalkWidth;
	bool	valid_split_layout = false;
	int		split_layout;
	bool	valid_split_barplace = false;
	int		split_barplace;
	if (witalk2_ptr->getItalkHost() && userno >= 9900) {
		char	regvalname[BUFSIZE];
		sprintf(regvalname, "Position_%s_%u_%u", witalk2_ptr->getItalkHost(), witalk2_ptr->getItalkPort(), userno);
		RECT	rc;
		if (pManager->Read(regvalname, rc, rc)) {
			xrc = lgWindow::MoveWindowVisible(rc);
			xrc.bottom = xrc.bottom - xrc.top; xrc.right = xrc.right - xrc.left;
		}
		sprintf(regvalname, "Splstyle_%s_%u_%u", witalk2_ptr->getItalkHost(), witalk2_ptr->getItalkPort(), userno);
		valid_split_layout = !!pManager->Read(regvalname, split_layout);
		sprintf(regvalname, "Splbarplace_%s_%u_%u", witalk2_ptr->getItalkHost(), witalk2_ptr->getItalkPort(), userno);
		valid_split_barplace = !!pManager->Read(regvalname, split_barplace);
	}

	HWND	hwnd = CreateWindowEx(NULL, (userno >= 9900) ? peerwc.classnameSubroom() : peerwc.classnameTelegram(), "(Untitled)", WS_OVERLAPPEDWINDOW, xrc.left, xrc.top, xrc.right, xrc.bottom, 0, 0,
								  (HINSTANCE)GetWindowLongPtr(witalk2_ptr->Hwnd(), GWL_HINSTANCE), 0);
	_ASSERT(hwnd);

	if (valid_split_layout) SendMessage(hwnd, WM_COMMAND, rCommandSetSpllayout, (LPARAM)split_layout);
	if (valid_split_barplace) SendMessage(hwnd, WM_COMMAND, rCommandSetSplbarplace, (LPARAM)split_barplace);

	// Waffle 0.2.1: EBhE
	if (windll._SetLayeredWindowAttributes && does_telegram_window_transparent){
		SetWindowLongPtr(hwnd, GWL_EXSTYLE, GetWindowLongPtr(hwnd, GWL_EXSTYLE) | WS_EX_LAYERED);
		windll._SetLayeredWindowAttributes(hwnd, 0, window_transparency, LWA_ALPHA);
	}

	ShowWindow(hwnd, SW_SHOWNOACTIVATE);
	UpdateWindow(hwnd);
	// uid bZ[WŒʒm
	SendMessage(hwnd, WM_COMMAND, rCommandSetUid, userno);
	// EBhE^Cg̍XV
	setPeerTelegramWindowTitle(hwnd, user);
}



class DialogUsers : public lgDialog
{
	int mode; // 1:Ȉ 2:ڍ 3:JX^
	BOOL is_topmost; // ɎOɕ\邩ǂ
	HWND hwnd_owner; // owner  hwnd
	//lgRegistry registry; // WXg
	ProfileManager* m_pProfileManager;//vt@C
	bool is_shrunk;	// EBhE^Cgo[݂̂̏Ԃ
	int	do_shrink;
	int	shrink_limit;
	int do_zsync;

	// WXg玩shrinkݒǂݏo
	void readreg_shrink ()
	{
		m_pProfileManager->Read("UsersAutoShrink", do_shrink, 1);
		m_pProfileManager->Read("UsersAutoShrinkLimit", shrink_limit, 10);
		m_pProfileManager->Read("UsersZOrderSync", do_zsync, 1);
	}

	// WXg CustomUsers Ԃ
	int getreg_CustomUsers(void)
	{
		int value;
		m_pProfileManager->Read("CustomUsers", value, 9); // 0, 3 (user#, handle)
		return value;
	}

	// CAEg
	void set_layout()
	{
		// Waffle 0.2.1: 
		if (windll._SetLayeredWindowAttributes){
			usersWindow = Hwnd();
			if (does_users_window_transparent){
				SetWindowLongPtr(Hwnd(), GWL_EXSTYLE, GetWindowLongPtr(Hwnd(), GWL_EXSTYLE) | WS_EX_LAYERED);
				windll._SetLayeredWindowAttributes(Hwnd(), 0, window_transparency, LWA_ALPHA);
			} else {
				windll._SetLayeredWindowAttributes(Hwnd(), 0, 255, LWA_ALPHA);
				SetWindowLongPtr(Hwnd(), GWL_EXSTYLE, GetWindowLongPtr(Hwnd(), GWL_EXSTYLE) & ~WS_EX_LAYERED);
			}
		}

		// F
		ListView_SetTextColor(Hwnd(rListUsers), ItalkView::GetColor(witalk2_ptr->foColorInput));
		ListView_SetTextBkColor(Hwnd(rListUsers), ItalkView::GetColor(witalk2_ptr->bkColorInput));
		ListView_SetBkColor(Hwnd(rListUsers), ItalkView::GetColor(witalk2_ptr->bkColorInput));

		// ʒu
		RECT rc;

		GetClientRect(toolbar->Hwnd(), &rc);
		int toolbar_height = rc.bottom + TOOLBAR_MAGIC_NUMBER; // Toolbar ̍

		int list_width = 4; // rListUsers ̕
		int cu = 0x7f; // ǂ̃J\邩
		if      (mode == 1) cu = 8; // 3 (handle)
		else if (mode == 3) cu = getreg_CustomUsers();

		for (int i = 0; i < 6; i++) {
			if (cu & (1 << i)) {
				ListView_SetColumnWidth(Hwnd(rListUsers), i, LVSCW_AUTOSIZE);
				list_width += ListView_GetColumnWidth(Hwnd(rListUsers), i);
			} else {
				ListView_SetColumnWidth(Hwnd(rListUsers), i, 0);
			}
		}

		int list_height = 4; // rListUsers ̍
		int num = ListView_GetItemCount(Hwnd(rListUsers));
		if (num) {
			ListView_GetItemRect(Hwnd(rListUsers), 0, &rc, LVIR_BOUNDS);
			list_height += rc.top + (rc.bottom - rc.top) * num;
		} else {
			list_height = 20;
		}

		/* Waffle 0.1.11:   Waffle 0.1.6 pb` Xe[^X΍ 炵B*/
		if ( list_width > 480 ) list_width = 480;

		int width  = list_width; // NCAg̈̕
		int height = toolbar_height + list_height; // NCAg̈̍
		GetClientRect(Hwnd(rStaticItalkServer), &rc);
		if (cu & 0x40) height += rc.bottom; // rStaticItalkServer ̍𑫂
		int sis_height = rc.bottom; // rStaticItalkServer ̍

		MoveWindow(Hwnd(rListUsers), 0, toolbar_height, list_width, list_height, FALSE);
		MoveWindow(Hwnd(rStaticItalkServer), 0, toolbar_height + list_height, list_width, sis_height , FALSE);
		SetRect(&rc, 0, 0, width, height);
		AdjustWindowRectEx(&rc, GetWindowLongPtr(Hwnd(), GWL_STYLE), FALSE, GetWindowLongPtr(Hwnd(), GWL_EXSTYLE));
		ResizeWindow(Hwnd(), rc.right - rc.left, (is_shrunk) ? (0) : (rc.bottom - rc.top), FALSE);
		InvalidateRect(Hwnd(), NULL, TRUE);
		toolbar->PressButton(rCommandDialogUsersSmall,  (mode == 1));
		toolbar->PressButton(rCommandDialogUsersBig  ,  (mode == 2));
		toolbar->PressButton(rCommandDialogUsersCustom, (mode == 3));

		SetWindowPos(Hwnd(), is_topmost ? HWND_TOPMOST : HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		toolbar->PressButton(rCommandDialogUsersTopMost, is_topmost);
	}
  
public:
 
	DialogUsers(HWND _hwnd) : lgDialog(_hwnd), mode(1), is_topmost(TRUE), is_shrunk(true), do_shrink(1), shrink_limit(10),do_zsync(1) { }

	~DialogUsers()
	{
		delete toolbar;
		RECT rc;
		GetWindowRect(Hwnd(), &rc);
		m_pProfileManager->Write("PositionUsers", rc);
		m_pProfileManager->Write("UsersMode", mode);
		m_pProfileManager->Write("IsTopMost", is_topmost);
	}

	// WM_INITDIALOG
	BOOL wmInitDialog(HWND /* focus */, LPARAM lParam)
	{
		DialogUsersInit *dui = (DialogUsersInit *)lParam;
		m_pProfileManager = dui->pProfileManager;
		_ASSERT( m_pProfileManager != NULL );

		readreg_shrink();

		m_pProfileManager->Read("UsersMode", mode, 0);

		HANDLE hicon = LoadIcon(lgWindows::hInst(), MAKEINTRESOURCE(rIconWItalk2));
		SetClassLong(Hwnd(), GCL_HICON, (LONG)hicon);

		toolbar = lgcToolbar::newCreate(Hwnd(), rToolbarUsers16, rToolbarUsers16, rToolbarUsers16, FALSE);

		// Waffle 0.2.0pre-0: gւ̃|C^ۑ
		usersDialogPtr = (void*)this;

		int tab_string[] = {
			rStringUserUserNo,
			rStringUserUptime,
			rStringUserIdle,
			rStringUserHandle,
			rStringUserHost,
			rStringUserStatus,
		};
		LV_COLUMN lvc;
		lvc.mask = LVCF_FMT | LVCF_TEXT | LVCF_SUBITEM;
		lvc.fmt = LVCFMT_LEFT;
		for (int i = 0; i < ArrayNum(tab_string); i++) {
			lvc.pszText = LoadString(tab_string[i]);
			lvc.iSubItem = i;
			ListView_InsertColumn(Hwnd(rListUsers), i, &lvc);
		}
    
		//lgRegistry registry(REGISTRY_ROOT);
		m_pProfileManager->Read("IsTopMost", is_topmost, is_topmost);

		hwnd_owner = dui->hwnd_owner;

		wmDialogNotify(dui->italk_info);

		// Waffle 0.2.2beta5
		//   by Kit 2001/03/22
		ListView_SetExtendedListViewStyle(Hwnd(rListUsers), LVS_EX_FULLROWSELECT);    

		RECT rc;
		if (m_pProfileManager->Read("PositionUsers", rc, rc)) MoveWindow(Hwnd(), &rc, TRUE);

		return TRUE;
	}
  
	// TCYύX
	BOOL wmSize(int size_type, int width, int height)
	{
		lgMainWindow::wmSize(size_type, width, height);

		RECT rc;
		GetClientRect(toolbar->Hwnd(), &rc);
		int toolbar_height = rc.bottom + TOOLBAR_MAGIC_NUMBER; // Toolbar ̍

		int list_height = height - toolbar_height;
		GetClientRect(Hwnd(rStaticItalkServer), &rc);
		if (mode == 2 || (mode == 3 && (getreg_CustomUsers() & 0x40))) list_height -= rc.bottom;
		list_height = abs(list_height);

		ResizeWindow(Hwnd(rListUsers), width, list_height, FALSE);
		MoveWindow(Hwnd(rStaticItalkServer), 0, toolbar_height + list_height, width, rc.bottom, FALSE);

		InvalidateRect(Hwnd(), NULL, TRUE);
		return TRUE;
	}

	void restartShrinkTimer()
	{
		KillTimer(Hwnd(), UINT_PTR(4624+10));
		SetTimer(Hwnd(), UINT_PTR(4624+10), shrink_limit*1000, NULL);
	}

	void resetShrinkTimer()
	{
		restartShrinkTimer();
		is_shrunk = false;
	}

	void resetShrinkState()
	{
		POINT	p;
		if (GetCursorPos(&p)) {
			RECT	rc;
			GetWindowRect(Hwnd(), &rc);
			if (rc.top <= p.y && rc.bottom >= p.y && rc.left <= p.x && rc.right >= p.x) { restartShrinkTimer(); return; }
		}
		is_shrunk = true & !!do_shrink;
		set_layout();
		restartShrinkTimer();
	}

	// 
	BOOL wmDialogNotify(ItalkInfo *italk_info)
	{
		if (!italk_info) {	// WXgēǍ
			readreg_shrink();
			if (!do_shrink) { resetShrinkState(); set_layout(); }
			return TRUE;
		}
		static vector<ItalkInfo::User>	oldusers;
		if (italk_info && italk_info->info) {
			int		 i = 0;
			while (true) {
				if (oldusers.size() == 0 || (unsigned)i > oldusers.size()) goto cmpmiss;
				ItalkInfo::User* user = italk_info->GetUserFromIndex(i);
				if (!user && oldusers.size() > (unsigned)i) goto cmpmiss;
				if (!user) break;
				if (user->userno != oldusers[i].userno) goto cmpmiss;
				if (user->Handle() && oldusers[i].Handle()) {
					if (user->handle.compare(oldusers[i].handle) != 0) goto cmpmiss;
				} else if (user->Handle() || oldusers[i].Handle()) goto cmpmiss;
				if (user->Host() && oldusers[i].Host()) {
					if (user->host.compare(oldusers[i].host) != 0) goto cmpmiss;
				} else if (user->Host() || oldusers[i].Host()) goto cmpmiss;
				if (user->Status() && oldusers[i].Status()) {
					if (user->status.compare(oldusers[i].status) != 0) goto cmpmiss;
				} else if (user->Status() || oldusers[i].Status()) goto cmpmiss;
				if (user->uptime != oldusers[i].uptime || user->idle != oldusers[i].idle) goto cmpmiss;
				i++;
			}
			AQT(("italk_info NOT changed.\n"));
			return TRUE;
cmpmiss:
			AQT(("italk_info CHANGED.\n"));
			oldusers.clear();
			int		j = 0;
			while (true) {
				ItalkInfo::User* user = italk_info->GetUserFromIndex(j++);
				if (!user) break;
				oldusers.push_back(*user);
			}
		}
		resetShrinkTimer();
		if (italk_info) {
			ListView_DeleteAllItems(Hwnd(rListUsers));
			ItalkInfo::Server *server = italk_info->GetServer();
			if (server) {
				char buf[BUFSIZE] = "";
				int len;
				if (server->Announce()) {
					strcpy(buf, "Announce: ");
					len = strlen(buf);
					wcstombs(buf + len, server->Announce(), sizeof(buf) - len);
					strcat(buf, "\n");
				}
				if (server->Host()) {
					strcat(buf, "ItalkServer: ");
					len = strlen(buf);
					wcstombs(buf + len, server->Host(), sizeof(buf) - len);
					sprintf(buf + strlen(buf), ":%d\n", server->Port());
				}
				sprintf(buf + strlen(buf), "%d users logged in\n", server->Users());
				time_t t = server->BootTime();
				sprintf(buf + strlen(buf), "Boot Time: %s", ctime(&t));
				t = server->CurrentTime();
				sprintf(buf + strlen(buf), "Current Time: %s", ctime(&t));
				int u = server->UpTime();
				sprintf(buf + strlen(buf), "Uptime: %d days %02d:%02d:%02d\n",
						u / 60 / 60 / 24,
						u / 60 / 60 % 24,
						u / 60 % 60,
						u % 60);
				if (server->LogCode()) {
					strcat(buf, "LogCode: ");
					len = strlen(buf);
					wcstombs(buf + len, server->LogCode(), sizeof(buf) - len);
					strcat(buf, "\n");
				}
				SetWindowText(rStaticItalkServer, buf);
			}

			for (int i = 0; ; i++) {
				ItalkInfo::User *user = italk_info->GetUserFromIndex(i);
				if (!user) break;

				char buf[BUFSIZE];
				sprintf(buf, "(%04d)", user->UserNo());
				LV_ITEM lvi;
				lvi.mask     = LVIF_TEXT;
				lvi.iItem    = i;
				lvi.iSubItem = 0;
				lvi.pszText  = buf;
				ListView_InsertItem(Hwnd(rListUsers), &lvi);

				sprintf(buf, "%02d:%02d",
						user->UpTime() / 60 / 60,
						user->UpTime() / 60 % 60);
				lvi.iSubItem = 1;
				ListView_SetItem(Hwnd(rListUsers), &lvi);

				sprintf(buf, "%02d:%02d",
						user->Idle() / 60 / 60,
						user->Idle() / 60 % 60);
				lvi.iSubItem = 2;
				ListView_SetItem(Hwnd(rListUsers), &lvi);

				if (user->Handle()) wcstombs(buf, user->Handle(), sizeof(buf)); else strcpy(buf, "?");
				lvi.iSubItem = 3;
				ListView_SetItem(Hwnd(rListUsers), &lvi);

				if (user->Handle()) wcstombs(buf, user->Host(), sizeof(buf)); else strcpy(buf, "?");
				lvi.iSubItem = 4;
				ListView_SetItem(Hwnd(rListUsers), &lvi);

				if (user->Status()) {
					wcstombs(buf, user->Status(), sizeof(buf));
					lvi.iSubItem = 5;
					ListView_SetItem(Hwnd(rListUsers), &lvi);
				}
			}
			set_layout();
		}
		return TRUE;
	}

	// WM_SHOWWINDOW
	BOOL wmShowWindow(BOOL does_become_showon, int /* status */)
	{
		if (does_become_showon)
			set_layout();
		return TRUE;
	}

	// Waffle 0.2.0pre-0: (X, Y) W烊Xg{bNX index Zo
	int convertXYtoIndex(int x, int y)
	{
		// LB_ITEMFROMPOINT łł͂AHwnd(rListUsers)  SendMessage ĂȂɂĂȂ ( LB_GETSEL 
		// ͂cc) ̂ŁAXg{bNXɗ炸͂Ŏ擾 (s)
		int		items = ListView_GetItemCount(Hwnd(rListUsers));
		RECT	rcList;
		GetWindowRect(Hwnd(rListUsers), &rcList);
		if (x < rcList.left || x > rcList.right || y < rcList.top || y > rcList.bottom) return -1;
		double	nx = x - rcList.left, ny = y - rcList.top;
		double	lineHeight = ceil((rcList.bottom - rcList.top)/(items+1));
		return	(int)(ny / lineHeight) - 1;
	}

	// Waffle 0.2.0pre-1: (X, Y) WXg{bNXۂԂ
	bool isInListBox(int x, int y)
	{
		RECT	rcList;
		GetWindowRect(Hwnd(rListUsers), &rcList);
		if (x >= rcList.left && x <= rcList.right && y >= rcList.top && y <= rcList.bottom) return true;
		return false;
	}

#if 0
	// Waffle 0.2.0: t@CM
	void wmCommandFileSend()
	{
		ItalkInfo::User* user = witalk2_ptr->italk_info.GetUserFromIndex(selectedIndex);
		if (user == 0){ MessageBox(0, "t@CM̎擾Ɏs܂", "G[", MB_OK); return; }
		// VXbhɈnf[^̏
		FileTransferInfo* fti = new FileTransferInfo();
		wcstombs(fti->handle, user->handle.c_str(), 1024);
		fti->userno = user->userno;
		// VXbhi
		unsigned int thread_handle = _beginthread(SendFileThread, 0, fti);
	}
#endif

#if 0
	// Waffle 0.2.0: t@CM
	void wmCommandFileReceive()
	{
		ItalkInfo::User* user = witalk2_ptr->italk_info.GetUserFromIndex(selectedIndex);
		if (user == 0){ MessageBox(0, "t@CM̎擾Ɏs܂", "G[", MB_OK); return; }
		// VXbhɈnf[^̏
		FileTransferInfo* fti = new FileTransferInfo();
		wcstombs(fti->handle, user->handle.c_str(), 1024);
		fti->userno = user->userno;
		// VXbhi
		unsigned int thread_handle = _beginthread(ReceiveFileThread, 0, fti);
	}
#endif

	// WM_COMMAND
	BOOL wmCommand(int notify_code, int id, HWND hwnd_control)
	{
		// Waffle 0.2.0pre-0: user ꗗ_CAOł̉ENbNj[
		switch(id){
#if 0
		case rCommandFileSend:		wmCommandFileSend();     return TRUE;
		case rCommandFileReceive:	wmCommandFileReceive();  return TRUE;
#endif
		case rCommandUserTelegram:	wmCommandUserTelegram(notify_code); return TRUE;
		}
		switch (id) {
		case rCommandDialogUsersSmall:   return wmCommand_UsersSmall();
		case rCommandDialogUsersBig:     return wmCommand_UsersBig();
		case rCommandDialogUsersCustom:  return wmCommand_UsersCustom();
		case rCommandDialogUsersRefresh: return wmCommand_UsersRefresh();
		case rCommandDialogUsersTopMost: return wmCommand_UsersTopMost();
		case rCommandDialogUsersMoveTop: return wmCommand_UsersMoveTop();
		}
		return TRUE;
	}

	// Small
	BOOL wmCommand_UsersSmall(void)
	{
		mode = 1;
		set_layout();
		return TRUE;
	}

	// Big
	BOOL wmCommand_UsersBig(void)
	{
		mode = 2;
		set_layout();
		return TRUE;
	}

	// Custom
	BOOL wmCommand_UsersCustom(void)
	{
		mode = 3;
		set_layout();
		return TRUE;
	}

	// ŐV̏ɍXV
	BOOL wmCommand_UsersRefresh(void)
	{
		/* Waffle 0.1.11: /wa Mɂĕ` */
		witalk2_ptr->send_str(L"/wa\r\n");
		PostMessage(hwnd_owner, WM_DIALOGNOTIFY, rDialogUsers, FALSE);
		return TRUE;
	}

	// ɎOɕ\邩ǂ
	BOOL wmCommand_UsersTopMost(void)
	{
		is_topmost = !is_topmost;
		set_layout();
		return TRUE;
	}
  
	// ݒ肳ĂΎOɈړ
	BOOL wmCommand_UsersMoveTop()
	{
		if (do_zsync) SetWindowPos(hwnd, (is_topmost) ? HWND_TOPMOST : HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		return TRUE;
	}

	// 
	BOOL wmClose(void)
	{
		PostMessage(hwnd_owner, WM_DIALOGNOTIFY, rDialogUsers, TRUE);
		witalk2_ptr->dialog_users_menuoff();
		return TRUE;
	}

	// }EXJ[\EBhEړƂɃTCYA
	BOOL wmMouseMove(WPARAM keys, int x, int y)
	{
		if (is_shrunk) { resetShrinkTimer(); set_layout(); } else restartShrinkTimer();
		return 0;
	}

	BOOL wmNcMouseMove(WPARAM wParam, int x, int y)
	{
		if (is_shrunk) { resetShrinkTimer(); set_layout(); } else restartShrinkTimer(); 
		return 0;
	}

	BOOL wmSetCursor(WPARAM wParam, int hittest, int mousemsg)
	{
		if (is_shrunk) { resetShrinkTimer(); set_layout(); } else restartShrinkTimer();
		return 0;
	}

	// ^C}
	BOOL wmTimer(WPARAM wParam, TIMERPROC* timerproc)
	{
		if (do_shrink && !is_shrunk) resetShrinkState(); 
		return 0;
	}

};

// Waffle 0.2.0pre-0: 
//   Xg̉ENbN WM_CONTEXTMENU Ă炵̂
//   𗘗păj[ov
void wmContextMenuDialog(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	int		ypos = (lParam >> 16) & 0xFFFF, xpos = lParam & 0xFFFF;
	HMENU	hPopupMenuUser;
	// Waffle 0.2.2beta5: uid 擾@C (by Kit)
	//
	//selectedIndex = ((DialogUsers*)usersDialogPtr)->convertXYtoIndex(xpos, ypos);
	// LVM_GETSELECTIONMARK 𑗂ΑɑIĂs index 擾ł͂
	// Ȃ`ĂȂƌăRpCɎŝňȉ̎@ƂB
	// CommCtrl.h łƒ`Ă̂ɂȂ(;_;)
	selectedIndex = -1;
	for (int i = 0; i < SendMessage(((DialogUsers *)usersDialogPtr)->Hwnd(rListUsers), LVM_GETITEMCOUNT, 0, 0); i++) {
		if (SendMessage(((DialogUsers *)usersDialogPtr)->Hwnd(rListUsers), LVM_GETITEMSTATE, i, LVIS_SELECTED) & LVIS_SELECTED) {
			selectedIndex = i;
			break;
		}
	}
	hPopupMenuUser = LoadMenu((HINSTANCE)GetWindowLongPtr(witalk2_ptr->Hwnd(), GWL_HINSTANCE), MAKEINTRESOURCE(rMenuPopupUser));
	hPopupMenuUser = GetSubMenu(hPopupMenuUser, 0);
	/* [UꗗOł̉ENbNȂDF */
	bool	inrange = ((DialogUsers*)usersDialogPtr)->isInListBox(xpos, ypos);
	EnableMenuItem(hPopupMenuUser, rCommandUserTelegram, (inrange ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenuUser, rCommandFileSend, (inrange ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenuUser, rCommandFileReceive, (inrange ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	/* T|[gĂȂ@\͊DF */
	EnableMenuItem(hPopupMenuUser, rCommandFileSend, MF_GRAYED | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenuUser, rCommandFileReceive, MF_GRAYED | MF_BYCOMMAND);
	// Waffle 0.2.2beta6: Ŝߑ΍
	SetForegroundWindow(hwnd);
	TrackPopupMenu(hPopupMenuUser, 0, xpos, ypos, 0, hwnd, NULL);
	PostMessage(hwnd, WM_NULL, 0, 0);
}

BOOL CALLBACK DialogUsersDlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	// Waffle 0.2.0pre-0: ENbNȂƂďE
	if (message == WM_CONTEXTMENU){
		wmContextMenuDialog(hwnd, wParam, lParam);
	}
#define lgWindowClass DialogUsers
	if (!lgwc) switch (message) {
		lgwmInitDialog;
	} else switch (message) {
		lgwmSize;
		lgwmNotify;
		lgwmCommand;
		lgwmClose;
		lgwmShowWindow;
		lgwmSysColorChange;
		lgwmMouseMove;
		lgwmNCMouseMove;
		lgwmSetCursor;
		lgwmTimer;
	case WM_DIALOGNOTIFY:
		return lgwc->wmDialogNotify((ItalkInfo *)lParam);
	}
	return lgwc->Default(message, wParam, lParam);
}
