/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogUsersOptions.cxx


#include	<winsock2.h>
#include "Dialog.h"
#include "lgDialog.h"

#include "TrapFocus.h"
#include "profilemanager.h"
#include "WItalk2.h"


class DialogUsersOptions : public lgDialog
{
	//lgRegistry registry;
	ProfileManager* m_pProfileManager;
	HWND hwnd_checks[7];
	HWND hwnd_users[3];

	int	users_update;

public:

	DialogUsersOptions(HWND _hwnd) : lgDialog(_hwnd)/*,registry(REGISTRY_ROOT)*/
	{
		{ for (int i = 0; i < ArrayNum(hwnd_checks); i++) hwnd_checks[i] = NULL; }
		{ for (int i = 0; i < ArrayNum(hwnd_users); i++) hwnd_users[i] = NULL; }
	}

	// WM_INITDIALOG
	BOOL wmInitDialog(HWND /* focus */, LPARAM lParam )
	{
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );
		hwnd_checks[0] = Hwnd(rCheckUserNo);
		hwnd_checks[1] = Hwnd(rCheckUptime);
		hwnd_checks[2] = Hwnd(rCheckIdle);
		hwnd_checks[3] = Hwnd(rCheckHandle);
		hwnd_checks[4] = Hwnd(rCheckHost);
		hwnd_checks[5] = Hwnd(rCheckStatus);
		hwnd_checks[6] = Hwnd(rCheckServer);

		int value;
		m_pProfileManager->Read("CustomUsers", value, 9); // 0, 3 (user#, handle)

		for (int i = 0; i < 7; i++) Button_SetCheck(hwnd_checks[i], value & (1 << i));

		m_pProfileManager->Read("UsersAutoShrink", value, 1);
		Button_SetCheck(Hwnd(rCheckUsersListAutoShrink), value);
		m_pProfileManager->Read("UsersAutoShrinkLimit", value, 10);
		char	users_auto_shrink_interval[1024];
		sprintf(users_auto_shrink_interval, "%u", value);
		SetWindowText(Hwnd(rEditUserListShrinkLimit), users_auto_shrink_interval);

		m_pProfileManager->Read("UsersZOrderSync", value, 1);
		Button_SetCheck(Hwnd(rCheckUserListFocusZ), value);

		return TRUE;
	}

	// OK ͍XV
	BOOL wmNotify_psnApply(void)
	{
		int value = 0;
		for (int i = 0; i < 7; i++) if (Button_GetCheck(hwnd_checks[i])) value |= (1 << i);
		m_pProfileManager->Write("CustomUsers", value);

		value = 0;
		m_pProfileManager->Write("UsersAutoShrink", Button_GetCheck(Hwnd(rCheckUsersListAutoShrink)));
		char	users_auto_shrink_interval[1024];
		GetWindowText(Hwnd(rEditUserListShrinkLimit), users_auto_shrink_interval, sizeof(users_auto_shrink_interval));
		value = atoi(users_auto_shrink_interval);
		if (value <= 0) value = 10;
		m_pProfileManager->Write("UsersAutoShrinkLimit", value);

		m_pProfileManager->Write("UsersZOrderSync", Button_GetCheck(Hwnd(rCheckUserListFocusZ)));

		SendMessage(witalk2_ptr->hwnd_dialog_users, WM_DIALOGNOTIFY, 0, 0);

		SendMessage(HwndPropertySheetOwner(), WM_DIALOGNOTIFY, rDialogUsersOptions, TRUE);
		return lgDialog::wmNotify_psnApply();
	}

	// WM_COMMAND
	BOOL wmCommand(int notify_code, int id, HWND hwnd_control)
	{
		{ for (int i = 0; i < 7; i++) if (hwnd_control == hwnd_checks[i]) return wmCommand_Checks(); }
		{ for (int i = 0; i < 3; i++) if (hwnd_control == hwnd_users[i]) return wmCommand_users(i); }
		if (hwnd_control == Hwnd(rCheckUsersListAutoShrink)) {
			EnableWindow(Hwnd(rEditUserListShrinkLimit), Button_GetCheck(Hwnd(rCheckUsersListAutoShrink)));
		}
		return TRUE;
	}

	// Users WI{^̑I
	BOOL wmCommand_users(int i)
	{
		switch(i){
		case 0: users_update = 0; break;
		case 1: users_update = 1; break;
		case 2: users_update = 2; break;
		}
		PropertySheetChanged();
		return TRUE;
	}

	// F(?)I΂ꂽ
	BOOL wmCommand_Checks(void)
	{
		PropertySheetChanged();
		return TRUE;
	}
};


BOOL CALLBACK DialogUsersOptionsDlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogUsersOptions
	if (!lgwc) switch (message) {
		lgwmInitDialog;
	} else switch (message) {
		lgwmCommand;
	}
	return lgwc->Default(message, wParam, lParam, TRUE);
}
