// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// ItalkView.h


#pragma	once



#include	"iWItalk2.h"
#include	"TrapFocus.h"
#include	"lgcRichEdit.h"

#include	<string>
#include	<map>
using namespace std;

class WItalk2;

// Italk ̃bZ[W\
class ItalkView {

	// Waffle 0.1.1: WItalk2* ւ̃|C^
	//void* witalk2parent;
	WItalk2* witalk2parent;//ύX by sept @ 2002/6/8

	// TuNXp
	WNDPROC old_wnd_proc;

public:

	BOOL  m_bPostQuitMsg;
	int		lastScrolledLineCount;		// Waffle 0.2.1

	void setOldWndProc(WNDPROC);

	void setSubclass(bool isInputBuffer);
	void setSubclass(bool isInputBuffer, ReSubClass* dataptr);

	ReSubClass*	scdata;
	
	class ColorPattern {
		wstring pattern;
		COLORREF color;

	public:
		ColorPattern(void) {pattern.clear();}
		~ColorPattern() {  }
		void Set(const wchar_t *color_pattern);
		const wchar_t *Pattern(void) { return pattern.c_str(); }
		COLORREF Color(void) { return color; }

	private:
		static int ctoi16(char c);
		static int ctoi16(wchar_t c);

	public:
		static void SetColor(char *buf, COLORREF c);
		static void SetColor(wchar_t *buf, COLORREF c);
		static COLORREF GetColor(const char *str);
		static COLORREF GetColor(const wchar_t *str);
		static const char *GetPattern(const char *str);
		static const wchar_t *GetPattern(const wchar_t *str);
	};

public:

	LOGFONT lf;
	COLORREF	*foColor, *bkColor;
	static int	fontheightTwip, lineheightTwip, pxPerInch;

private:

	CHARFORMAT2 color_cf;
	ColorPattern *color_pattern;
	int color_pattern_num;

	// b`GfBbgRg[Ɍ݂̃tHgݒ肷
	void set_current_font(BOOL does_set_color);
	void set_current_font2000(BOOL does_set_color);

	// b`GfBbgRg[͈̂͂ɐFݒ肷
	void set_color(int char_start, int char_end, COLORREF color);
	// b`GfBbgRg[͈̂͂ URL pݒ肷
	void set_urlunderline(int char_start, int char_end);

public:
	lgcRichEdit Re;

	ItalkView(HWND parent, WItalk2* witalk2_parent, COLORREF* foColor, COLORREF* bkColor, DWORD style = 0, DWORD default_style = WS_CHILD | WS_VISIBLE | ES_MULTILINE | WS_VSCROLL | ES_SUNKEN ); // Modified by sept
	~ItalkView();

	// ƃIuWFNg(Witalk2) ւ̃|C^ݒ
	void setParentPointer(WItalk2* witalk2_parent);

	// sԂݒ肷
	void SetLinegap();
	void SetLinegapSel();

	// WXgǂ
	void ReadRegistry(BOOL does_set_current_font);

	// eLXgԌɑ}
	void AddText(const wchar_t *text, BOOL does_autoscroll);

	// URL o
	bool detectUrl(const wchar_t* text, const wchar_t* id, int& start_idx, int& end_idx);

	// Ō̋s̐擪
	int MoveCaretToTheLast(void);

	// FƂėLȐFԂ
	static COLORREF GetColor(COLORREF color);
};
