#include	<winsock2.h>
#include <windows.h>
#include "profilemanager.h"
#include "iWitalk2.h"

using namespace std;

ProfileManager::ProfileManager(void)
{
	m_bProfileLoaded = FALSE;
	m_strProfileFileName.clear();
}

ProfileManager::~ProfileManager(void)
{
}

BOOL ProfileManager::newProfile()
{
	AQT(( "newProfile\n" ));
	m_Profile.clear();
    HKEY hkey;
    if (ERROR_SUCCESS == RegOpenKeyEx(REGISTRY_ROOT, 0, KEY_READ, &hkey))
    {
		
		DWORD index = 0;
		char name_buffer[BUFSIZE];
		while( true ){
			DWORD dwSize = BUFSIZE;
			DWORD dwType;
			DWORD dwValueSize;
			if( ERROR_SUCCESS == RegEnumValue( hkey, index, name_buffer, &dwSize, NULL, &dwType, NULL, &dwValueSize ) )
			{
				if( dwSize != 0 ){
					if( dwType == REG_SZ ){
						AQT(( "RegEnum(SZ) %s[%d]\n", name_buffer,dwValueSize ));
						char* pValue = new char[dwValueSize];
						if (ERROR_SUCCESS == RegQueryValueEx(hkey, name_buffer, NULL, &dwType, (BYTE*)pValue, &dwValueSize)){
							profile_Write( name_buffer, pValue );
						}
						delete [] pValue;
					}else if( dwType == REG_DWORD ){
						
						int buf;
						dwValueSize = sizeof(buf);
						if (ERROR_SUCCESS == RegQueryValueEx(hkey, name_buffer, NULL, &dwType, (BYTE*)&buf, &dwValueSize)){
							profile_Write( name_buffer, buf );
						}
					}
				}
			}else{
				break;
			}
			index++;

		}
		RegCloseKey(hkey);
    }
	m_bProfileLoaded = TRUE;
	return TRUE;
}
BOOL ProfileManager::profile_Write( const char* name, const char* value )
{
	if( !name ) return FALSE;
	AQT(( "profile_Write[%s]=%s\n", name, value ));
	m_Profile[ string(name) ] = string(value);
	
	return TRUE;
}
BOOL ProfileManager::profile_Write( const char* name, int value )
{
	if( !name ) return FALSE;
	AQT(( "profile_Write[%s]=%d\n", name, value ));
	char buf[128];
	_ASSERT( 0 < _snprintf( buf, 128, "%d", value ) );
	
	m_Profile[ string(name) ] = string(buf);
	return TRUE;
}
BOOL ProfileManager::loadProfile( const char* filename )
{
	FILE* fp = fopen( filename, "rt" );
	if( fp == NULL ){
		AQT(( "fopen(%s) failed\n", filename ));
		return FALSE;
	}
	m_Profile.clear();
	m_bProfileLoaded = TRUE;
	m_strProfileFileName = filename;
	char buf[BUFSIZE];
	while( fgets( buf, BUFSIZE, fp ) != NULL ){
		int length = strlen( buf );
		char* peq = strchr( buf, '=' );
		if( !peq ) continue;
		char* val = peq+1;
		*peq = NULL;
		peq = strchr( val, '\n' );
		if( peq ) *peq = '\0';
		if( val != NULL ){
			AQT(( "read %s = %s\n", buf, val ));
			m_Profile[ string(buf) ] = string( val );
		}
	}
	return TRUE;
}

BOOL ProfileManager::saveProfileAs( const char* filename )
{
	FILE* fp = fopen( filename, "wt" );
	if( fp == NULL ){
		AQT(( "fopen(%s) failed\n", filename ));
		return FALSE;
	}
	for( map<string,string>::iterator iter = m_Profile.begin() ; iter != m_Profile.end() ; iter++ )
	{
		fprintf( fp, "%s=%s\n", iter->first.c_str(), iter->second.c_str() );
	}
	fclose( fp );
	m_bProfileLoaded = TRUE;
	m_strProfileFileName = filename;
	return TRUE;
}

BOOL ProfileManager::Delete( const char* const name )
{
	if( isProfileLoaded() ){
		int n = m_Profile.erase( string(name) );
		return (n > 0);
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Delete( name );
	}
}
// DWORD ǂ
BOOL ProfileManager::Read(const char * const name, int &buf, int default_value )
{
	if( isProfileLoaded() ){
		if( name == NULL ){
			buf = default_value;
			return FALSE;
		}
		map<string,string>::iterator iter = m_Profile.find( string( name ) );
		if( iter == m_Profile.end() ){
			buf = default_value;
			return FALSE;
		}else{
			buf = atoi( iter->second.c_str() );
			return TRUE;
		}
		
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Read( name, buf, default_value );
	}
}

// DWORD 
BOOL ProfileManager::Write(const char * const name, int value)
{
	if( isProfileLoaded() ){
		return profile_Write( name, value );
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Write( name, value );
	}
}

// ǂ
BOOL ProfileManager::Read(const char * const name, char *buf, const DWORD sizeof_buf,
	const char *default_str )
{
	if( isProfileLoaded() ){
		map<string,string>::iterator iter = m_Profile.find( string( name ) );
		if( iter == m_Profile.end() ){
			if (default_str) strcpy(buf, default_str);
			return FALSE;
		}else{
			strncpy( buf, iter->second.c_str(), sizeof_buf - 1 );
			buf[sizeof_buf-1] = '\0';
			return TRUE;
		}
		return FALSE;
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Read( name, buf, sizeof_buf, default_str );
	}
}

// 
BOOL ProfileManager::Write(const char * const name, const char * const value)
{
	if( isProfileLoaded() ){
		return profile_Write( name, value );
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Write( name, value );
	}
}


// Chǂ
BOOL ProfileManager::Read(const char * const name, wchar_t *buf, const DWORD sizeof_buf,
	const wchar_t *default_str )
{
	if( isProfileLoaded() ){
		if (sizeof_buf <= 0)
			return FALSE;
		char *mbsbuf = (char *)_alloca(sizeof_buf * 2 + 1);
		map<string,string>::iterator iter = m_Profile.find( string( name ) );
		if( iter != m_Profile.end() ){
			if (0 <= mbstowcs(buf, iter->second.c_str(), sizeof_buf))
				return TRUE;
			
		}
		if( default_str ){
			wcscpy( buf, default_str );
		}
		return FALSE;

	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Read( name, buf, sizeof_buf, default_str );
	}
}


// Ch
BOOL ProfileManager::Write(const char * const name, const wchar_t * const value)
{
	if( isProfileLoaded() ){
		if (!value)
			return FALSE;
		int len = wcslen(value);
		char *mbsvalue = (char *)_alloca(len * 2 + 1);
		if (wcstombs(mbsvalue, value, len + 1) < 0)
			return FALSE;
		profile_Write( name, mbsvalue );
		return FALSE;
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Write( name, value );
	}
}

// oCiǂ
BOOL ProfileManager::Read(const char * const name, BYTE *buf, DWORD &sizeof_buf,
	const BYTE *default_binary , DWORD sizeof_default_binary )
{
	if( isProfileLoaded() ){
		_ASSERT( FALSE );
		return FALSE;
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Read( name, buf, sizeof_buf, default_binary, sizeof_default_binary );
	}
}

// oCi
BOOL ProfileManager::Write(const char * const name, const BYTE * const value,
		DWORD sizeof_value)
{
	if( isProfileLoaded() ){
		_ASSERT( FALSE );
		return FALSE;
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Write( name, value, sizeof_value );
	}
}

// LOGFONT ǂ
BOOL ProfileManager::Read(const char * const name, LOGFONT &lf,
	const char * const default_string_logfont )
{

	if( isProfileLoaded() ){
		char buf[BUFSIZE];
		map<string,string>::iterator iter = m_Profile.find( string( name ) );
		if( iter == m_Profile.end() ){
			if (!default_string_logfont) return FALSE;
			strcpy( buf, default_string_logfont );
		}else{
			strcpy( buf, iter->second.c_str() );
		}
		lf.lfHeight         =       atoi(_mbstok(buf,  ","));
		lf.lfWidth          =       atoi(_mbstok(NULL, ","));
		lf.lfEscapement     =       atoi(_mbstok(NULL, ","));
		lf.lfOrientation    =       atoi(_mbstok(NULL, ","));
		lf.lfWeight         =       atoi(_mbstok(NULL, ","));
		lf.lfItalic         = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfUnderline      = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfStrikeOut      = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfCharSet        = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfOutPrecision   = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfClipPrecision  = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfQuality        = (BYTE)atoi(_mbstok(NULL, ","));
		lf.lfPitchAndFamily = (BYTE)atoi(_mbstok(NULL, ","));
		strcpy(lf.lfFaceName, _mbstok(NULL, ","));
		return TRUE;
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Read( name, lf, default_string_logfont );
	}
}

// LOGFONT 
BOOL ProfileManager::Write(const char * const name, const LOGFONT &lf)
{
	if( isProfileLoaded() ){
		char buf[BUFSIZE];
		wsprintf(buf, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%s",
			lf.lfHeight, lf.lfWidth, lf.lfEscapement, lf.lfOrientation,
			lf.lfWeight, lf.lfItalic, lf.lfUnderline, lf.lfStrikeOut,
			lf.lfCharSet, lf.lfOutPrecision, lf.lfClipPrecision, lf.lfQuality,
			lf.lfPitchAndFamily, lf.lfFaceName);
		return profile_Write( name, buf );
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Write( name, lf );
	}
}

// RECT ǂ
BOOL ProfileManager::Read(const char * const name, RECT &rc, const RECT &default_rc)
{
	if( isProfileLoaded() ){
		char buf[BUFSIZE];
		map<string,string>::iterator iter = m_Profile.find( string( name ) );
		if( iter == m_Profile.end() ){
			rc = default_rc;
			return FALSE;
		}
		strcpy( buf, iter->second.c_str() );

		rc.left   = atoi(_mbstok(buf,  ","));
		rc.top    = atoi(_mbstok(NULL, ","));
		rc.right  = atoi(_mbstok(NULL, ","));
		rc.bottom = atoi(_mbstok(NULL, ","));
		return TRUE;
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Read( name, rc, default_rc );
	}
}

// RECT 
BOOL ProfileManager::Write(const char * const name, const RECT &rc)
{
	if( isProfileLoaded() ){
		char buf[BUFSIZE];
		wsprintf(buf, "%d,%d,%d,%d", rc.left, rc.top, rc.right, rc.bottom);
		return profile_Write( name, buf );
	}else{
		lgRegistry reg(REGISTRY_ROOT);
		return reg.Write( name, rc );
	}
}