//-------------------------------------
// aqLib - Trace 
// Function and Macros for Debugging
// Trace.h
//-------------------------------------

#pragma once

#include	<windows.h>

namespace aqx
{
	class CTrace
	{
	public:	
		static void LTAt( const char* file, DWORD dwLine );
		static void LTTrace( LPCSTR lpszFormat, ...);
	};
}

#ifdef _DEBUG
#	define AQT(msg) aqx::CTrace::LTAt(__FILE__,(DWORD)__LINE__); aqx::CTrace::LTTrace msg
#else
#	define AQT(msg)
#endif

#define EXIT_WITH_MSG(msg) do { MessageBox(0, msg, "WItalk2", MB_OK); ExitProcess(-1); } while (0)

#define	CATCH_BAD_ALLOC catch (bad_alloc) { EXIT_WITH_MSG("Out of Memory."); }
