// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItalk2.h

#pragma	once

#pragma warning(disable: 4996)

#include	<winsock2.h>
#include "iWItalk2.h"
#include "Sound.h"

#include <vector>
#include <list>
#include <string>
using	namespace std;

#include "BackLogWindow.h"

#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/ssl.h>
#include <openssl/err.h>


#define TOOLBAR_MAGIC_NUMBER 2

class BackLogWindow;
class ProfileManager;

LRESULT CALLBACK WItalk2WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

bool taskbarDelete(HWND hwnd);
bool taskbarAdd(HWND hwnd);

extern	LCID processLocale;
extern	void initLocale();

// CreateWindow̍Ō̈ɂ
// WM_CREATECREATESTRUCTlpCreateParamɓ
struct WItalk2CreateParam
{
	// newō쐬ꂽ WItalk2̃fXgN^
	ProfileManager* pProfileManager; 
};

class WItalk2 : public lgMainWindow, public ItalkConnectionNotify
{
	// Waffle 0.1.1
	friend ItalkView;

public:

	// ConnectTo
	HWND hwnd_combo_connectto;
	HWND hwnd_anim_connectto;
	HWND hwnd_button_connectto;
	HFONT hfont_combo_connectto;
	HIMAGELIST himl_anim_connectto;
	HBITMAP hbitmap_go;
	HBRUSH hbrush_background;
	// ItalkView
	HWND hwnd_tooltip;
	ItalkView *iv_input;
	ItalkView *iv_log_public;

	bool	tasktrayIcon;			// ^XNgCɃACR\
	bool	tasktrayStore;			// ^XNgCɎ[

	bool	isCheckedAutoScroll;
	HMENU	hPopupMenu;

	vector<BackLogWindow*>	backlogList;	// obNOEBhEIuWFNg̃Xg

	int		mainWindowWidth, mainWindowHeight;

	BOOL	is_backloging;					// obNO
	int		freeeditmode;					// RҏW[h

	// ^XNo[ċNʒm
	UINT	s_uTaskbarRestart;

	COLORREF	foColorInput, bkColorInput, bkColorLog, bkColorLogPublic, bkColorLogPrivate;

	// Message
	wstring ping;							// ping ̃}b`p^[
	Sound ping_beep;						// ping ̉
	vector<wstring> biff_sounds;			// BIFF ̉

	wstring handle;							// ̃nh

	int		last_userno_who_send_to_me;		// Ō /p Ăl
	int		last_userno_to_whom_i_send;		// Ō /p l
	wstring private_time;					// /p ̎
	int		previous_private_time;			// O /p ̎
	int		private_ping_interval;			// ȏ̕bԊuł /p  ping

	vector<wstring> kill_name_list;			// kill name ̃Xg

	HANDLE	mutex_log;						// ȉ̓̕ϐ mutex
	list<wstring> log_buffer;				// O
	list<wstring> untreated_log;			// O
	HANDLE	mutex_add_log;					// add_log ֐ mutex
	HANDLE	event_log_added;				// Oǉꂽ
	enum {
		log_thread_running,
		log_thread_terminating,
		log_thread_terminated
	} log_thread_mode;						// log_thread ̏

	// Message - TYM
	void	InfoUpdateRequest(bool imm = FALSE, bool reset = FALSE);
	HANDLE	mutex_update;					// ȉ2 mutex
	bool	isInInfoUpdateWait;
	int		infoUpdateWaitLine;

	// Splitbar
	HWND	hwnd_splitbar;
	HWND	hwnd_splitbar_log;
	HWND	hwnd_splitbar_public_private;

	// URL
	HWND	hwnd_url;
	HWND	hwnd_combo_url;
	HWND	hwnd_icon_url;
	HWND	hwnd_button_url;
	HFONT	hfont_combo_url;
	HICON	hicon_url;

	BackLogWindow* m_pCurrentLogWindow;

	// Pointer to ProfileManager 
	ProfileManager* m_pProfileManager;
	string	m_strProfileFileName;
	BOOL	m_bFirstProfileDlg;
	char	m_strProfileInitDir[_MAX_PATH];

	// Users
	HWND	hwnd_dialog_users;

	ItalkInfo italk_info;					// italk ɂĂ̏

private:
	
	int		next_p_userno;					//  /p Ŏgl

	// WItalk2
	HACCEL	haccel_main;					// ANZ[^
	HWND	hwnd_property[1];				// vpeB

public:

	lgMenu	menu;							// j[
	ItalkConnection ic;						// ItalkConnection
	
	bool servercaps_subroom;				// T[og@\
	bool servercaps_ssl;					//
	bool servercaps_xnop;					//

private:

	//lgRegistry registry;					// WXg
	bool	is_first_wmSetFocus;			// ŏ wmSetFocus ǂ

	// WItalk2 - TYM
	char	*szItalkHost;					// ڑ̎I
	u_short	uItalkPort;						// ڑ̃|[g
	int		lineCounter;					// sԍ (ItalkProtocol/ServerCapso)
	int		italkProtocolVersion;			// vgRo[W
	enum {
		infoUpdateUseWA,					// /wa R}hgp
		infoUpdateBiff,						// Biff |[ggp
		infoUpdateNone						// XVȂ
	} infoUpdate;

public:
	
	bool isConnectionActive;				// Italk Server Ɛڑǂ
	bool sendJIS;							// JIS R[hɕϊđM邩

private:
	
	// ConnectTo
	void read_registry_combo_color();
	HBRUSH ctl_color(HDC hdc);
	void combo_connectto_create();
	void combo_connectto_read_registry();
	void combo_connectto_destroy();
	void combo_connectto_resize();
	void combo_connectto_redraw();
	void combo_connectto_set_font();
	void combo_connectto_setfocus();
	void combo_connectto_connected();
	void combo_connectto_failed_to_connect();
	void combo_connectto_closed();
	void combo_connectto_error();
	BOOL combo_connectto_is_focused();
	BOOL combo_connectto_connect(const char *handlehostport = NULL);
	void subclass_wmCtlColor(HWND hwnd);
	static LRESULT CALLBACK ForwardWmCtlColorWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

	// ItalkView
	void iv_create();
	void iv_destroy();

public:
	
	void iv_set_keybinding(ItalkView *iv);

	ItalkView *iv_get_focused_only();
	ItalkView *iv_get_focused();
	void iv_set_font_and_bkcolor(BOOL does_set_font = TRUE);

#ifdef	USE_EMACS_KEYBIND
	void iv_use_emacs_key_binding(BOOL f);
#endif

	void set_tooltip(void);
	void send_str(const wchar_t *str);
	void send_str(const char* str);
	BOOL iv_send_current_line(BOOL does_send_emply_line_too = FALSE, ItalkView *iv = NULL, BOOL does_insert_newline = TRUE, BOOL telegramCast = FALSE, int toUserno = 0);
	BOOL iv_key_down(void);

	// Waffle 0.2.0: dze[u
	int	telegramDeliveryTableUserno[256];
	HWND telegramDeliveryTableHwnd[256];
	int telegramDeliveryMembers;
	void RegisterTelegramDeliveryTable(int userno, HWND hwnd);
	void UnregisterTelegramDeliveryTable(int userno, HWND hwnd);
	HWND SearchTelegramDeliveryTable(int userno);

	// Waffle 0.2.1b: ^XNgC
	NOTIFYICONDATA*	trayiconinfo;
	void initializeTrayiconinfo();
	void registerIconOnTasktray();
	void unregisterIconFromTasktray();
	void updateIconOnTasktray();
	int wmCommand_TasktrayNotify(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
	void PopupTasktrayMenu(HWND hwnd);
	int wmCommand_AllWindowsRestore();
	void AllTelegramWindowsRestore();
	void TelegramWindowRestore(int n);
	int wmCommand_MainWindowRestore();

	void BacklogWindowRestore(int n);

	// Message
	void message_init();
	BOOL terminate_log_thread();
	void message_end();
	void message_connected();
	void change_handle(const wchar_t *_handle);
	void clear_kill_name_list();
	void read_registry_for_kill_name();
	void clear_biff_sounds();
	void read_registry_for_biff_sounds();
	void read_registry_for_ping();
	void play_ping();
	void play_ping(bool f);
	void add_log(const wstring& str);
	void add_log(const string& str);
	static void log_thread(void *This);
	void log_thread();
	void log_thread_add_log(const wstring& str);
	void log_save_log();

	// Splitbar
	void splitbar_create();
	void splitbar_init_after_iv();
	void splitbar_read_registry();
	void splitbar_destroy();
	void splitbar_resize();

	// URL
	void url_create();
	void url_destroy();
	void url_resize();
	void url_redraw();
	void url_set_font();
	void url_setfocus();
	BOOL url_is_focused();
	BOOL url_open(BOOL force_open = FALSE);
	void url_add(const wchar_t *url);
	void url_toggle_display();
	BOOL url_is_displaied();

	// Users
	void dialog_users_init();
	void dialog_users_end();
	void dialog_users_update();
	void dialog_users_connected();
	void dialog_users_show();
	void dialog_users_menuon();
	void dialog_users_menuoff();
	void dialog_users_notify(BOOL does_hide);
	BOOL check_italk_info_string(const wchar_t *str);
	void complete_p(int direction = 1);
	BOOL check_private_message(wchar_t *line, BOOL &is_private_message);

	// WItalk2
	void show_error_message(const char *buf);
	void reset_focus();
	void paint(HDC hdc);
	void disconnect();
	void set_all();
	void set_font_and_bkcolor( BOOL does_set_font = TRUE );

	// WItalk2
	WItalk2(HWND _hwnd);
	~WItalk2();
	int wmCreate( CREATESTRUCT * cs );
	int wmMenuSelect(UINT item, UINT flags, HMENU hmenu);
	int wmPaint();
	int wmSetFocus(HWND /* hwnd_lose_focus */);
	int wmSize(int size_type, int width, int height);
	void Connected(ItalkConnection * ic);
	void FailedToConnect(ItalkConnection * /* ic */, int wsaerrno);
	void Disconnected(ItalkConnection * /* ic */);
	void ConnectionClosed(ItalkConnection * /* ic */);
	void Error(ItalkConnection * /* ic */, int wsaerrno);
	void DataArrived(ItalkConnection * /* ic */, const wchar_t *data);
	int wmDialogNotify_DialogUsers(BOOL does_hide);
	int wmDialogNotify_DialogColor(BOOL is_lf_updated);
	int wmDialogNotify_DialogItalkServer(BOOL does_read_registry);
	int wmDialogNotify_DialogKillName(BOOL does_read_registry);
	int wmDialogNotify_DialogSounds(BOOL does_read_registry);
	int wmDialogNotify_DialogUsersOptions(BOOL does_update);
	int wmDialogNotify_DialogOther(BOOL does_read_registry);
	int wmDialogNotify_DialogWindows2000(BOOL does_read_registry);
	int wmDialogNotify_DialogTelegram(BOOL does_read_registry);
	int wmDialogNotify_DialogURL(BOOL does_read_registry);
	int wmDialogNotify_DialogParanoia1(BOOL does_read_registry);
	HBRUSH wmCtlColorEdit(HDC hdc, HWND hwnd);
	int wmClose();
	int wmCommand(int /* notify_code */, int id, HWND hwnd_control);
	int wmCommand_ButtonConnectTo();
	int wmCommand_ButtonOpenURL();
	int wmCommand_Option(int page = 0);
	int wmCommand_ConnectionConnect();
	int wmCommand_ConnectionDisconnect();
	int wmCommand_ConnectionSetting();
	int wmCommand_EditUndo();
	int wmCommand_EditCut();
	int wmCommand_EditCopy();
	int wmCommand_EditPaste();
	int wmCommand_EditPasteToBeSent();	// Waffle 0.1.5
	int wmCommand_EditDelete();
	int wmCommand_EditQuotedPaste();
	int wmCommand_EditQuotedPasteToBeSent();	// Waffle 0.1.5
	void wmCommand_RichEditPaste(bool, bool, ItalkView*, wchar_t*);	// Waffle 0.1.9, 0.2.0
	int wmCommand_EditSendToItalk(ItalkView *_iv = NULL, ItalkView* = NULL, wchar_t* = NULL);
	int wmCommand_EditPasteSendToItalk();
	int wmCommand_EditQuotedPasteSendToItalk();
	int wmCommand_LogAutoScroll();
	int wmCommand_LogDisableAutoScrollWhenMinimized();
	int wmCommand_LogSetting();
	int wmCommand_LogSaveSetting();
	int wmCommand_OtherTelegram();
	int wmCommand_OtherShowTip();
	int wmCommand_OtherEcho();
	int wmCommand_OtherTopMost();
	int wmCommand_OtherUsers();
	int wmCommand_OtherEmacsKeyBinding();
	int wmCommand_OtherOpenURL();
	int wmCommand_OtherSetting();
	int wmCommand_About(int page = 0);
	int wmCommand_HelpAbout();
	int wmCommand_KeyEnter();
	int wmCommand_KeyShiftEnter();
	int wmCommand_KeyTab();
	int wmCommand_KeySTab();
	int wmCommand_KeyCTab();
	int wmCommand_KeyCSTab();
	int wmCommand_KeyCH();
	int wmCommand_showwindow();
	void send_vkey(HWND hwnd, int vkey, BOOL control = FALSE, BOOL shift = FALSE, BOOL alt = FALSE);
	int wmCommand_KeyDown();
	int wmCommand_KeyMNext();
	int wmCommand_KeyMPrior();
	int wmCommand_KeyCF6();
	int wmCommand_Quit();
	int wmCommand_ClearClipboard();
	int wmCommand_ToggleFreeEdit();
	int wmCommand_ClearBuffer();
	int wmAppConnectTo(const char *handlehostport);
	BOOL ProcessMessage(MSG &msg);
	static ATOM Register();

	int wmCommand_FileSend();
	int wmCommand_FileReceive();

	int wmCommand_OpenBackLogWindow();

	int wmCommand_ProfileNew();
	int wmCommand_ProfileOpen();
	int wmCommand_ProfileSave();
	int wmCommand_ProfileSaveAs();
	int wmCommand_ProfileAssociation();
	BackLogWindow* getCurrentLogWindow() { return m_pCurrentLogWindow; }

	char* getItalkHost() { return szItalkHost; }
	unsigned int getItalkPort(){ return uItalkPort; }

	ProfileManager* getProfileManager() { return m_pProfileManager; }
};

extern	WItalk2*	witalk2_ptr;
