// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItalk2ConnectTo.cxx


#include	<crtdbg.h>

#include	"WItalk2.h"
#include	"ProfileManager.h"

extern		bool	sent_handle;				// Waffle 0.1.11
extern		LOGFONT gbl_lf;					// Waffle 0.2.1

LOGFONT		gbl_lf;

void WItalk2::read_registry_combo_color(void)
{
	_ASSERT( m_pProfileManager );
	COLORREF bkcolor_input;
	m_pProfileManager->Read("BkColorInput", (int &)bkcolor_input, GetSysColor(COLOR_WINDOW));
	if( hbrush_background ) DeleteObject(hbrush_background);

	hbrush_background = CreateSolidBrush(ItalkView::GetColor(bkcolor_input));
}


HBRUSH WItalk2::ctl_color(HDC hdc)
{
	SetTextColor(hdc, ItalkView::GetColor(foColorInput));
	SetBkColor(hdc, ItalkView::GetColor(bkColorInput));
	return hbrush_background;
}


// toolbar ɌĂԂ
void WItalk2::combo_connectto_create(void)
{
	hbrush_background = NULL;

	read_registry_combo_color();

	TOOLINFO ti;
	ti.cbSize   = sizeof(TOOLINFO);
	ti.uFlags   = TTF_IDISHWND | TTF_SUBCLASS;
	ti.hinst    = NULL;

	// c[o[TuNX
	subclass_wmCtlColor(toolbar->Hwnd());

	// R{{bNX
	hwnd_combo_connectto = CreateWindowEx(NULL, "COMBOBOX", NULL,
										  WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_TABSTOP | CBS_DROPDOWN | CBS_AUTOHSCROLL,
										  0, 0, 1, 1, toolbar->Hwnd(), NULL, lgWindows::hInst(), NULL);
	_ASSERT(hwnd_combo_connectto);
	hfont_combo_connectto = NULL;

	ti.hwnd     = hwnd_combo_connectto;
	ti.uId      = (UINT)ti.hwnd;
	ti.lpszText = LoadString(rStringConnectToItalkServer);
	SendMessage(hwnd_tooltip, TTM_ADDTOOL, 0, (LPARAM)&ti);

	// {^
	hwnd_button_connectto = CreateWindowEx(NULL, "BUTTON", NULL, WS_CHILD | WS_VISIBLE | BS_BITMAP,
		0, 0, 1, 1, toolbar->Hwnd(), NULL, lgWindows::hInst(), NULL);
	_ASSERT(hwnd_button_connectto);
	hbitmap_go = (HBITMAP)LoadImage(lgWindows::hInst(), MAKEINTRESOURCE(rBitmapGo), IMAGE_BITMAP, 0, 0,
									LR_CREATEDIBSECTION | LR_LOADMAP3DCOLORS);
	SendMessage(hwnd_button_connectto, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hbitmap_go);

	ti.hwnd     = hwnd_button_connectto;
	ti.uId      = (UINT)ti.hwnd;
	ti.lpszText = LoadString(rStringConnectTo);
	SendMessage(hwnd_tooltip, TTM_ADDTOOL, 0, (LPARAM)&ti);

	// Aj[V
	hwnd_anim_connectto = CreateWindowEx(NULL, "lgcAnimation", NULL, WS_CHILD | WS_VISIBLE,
										 0, 0, 1, 1, toolbar->Hwnd(), NULL, lgWindows::hInst(), NULL);
	_ASSERT(hwnd_anim_connectto);
	himl_anim_connectto = ImageList_LoadImage(lgWindows::hInst(), MAKEINTRESOURCE(rBitmapConnecting), 32, 0,
											  CLR_NONE, IMAGE_BITMAP, LR_LOADMAP3DCOLORS | LR_CREATEDIBSECTION);
	lgcAnimation_SetImageList(hwnd_anim_connectto, himl_anim_connectto);

	combo_connectto_read_registry();

	combo_connectto_set_font();
}


// WXgǂŐݒ肷
void WItalk2::combo_connectto_read_registry(void)
{
	char buf[BUFSIZE];
	GetWindowText(hwnd_combo_connectto, buf, sizeof(buf));
	ComboBox_ResetContent(hwnd_combo_connectto);
	SetWindowText(hwnd_combo_connectto, buf);
	for (int i = 0; i < 64; i++) {	// Waffle 0.1.11: ItalkServer B(s)Ƃւ̑΍
		char name[BUFSIZE];
		sprintf(name, "ItalkServer%d", i);
		if (!m_pProfileManager->Read(name, buf, sizeof(buf))) break;
		ComboBox_AddString(hwnd_combo_connectto, buf);
		if (i == 0) SetWindowText(hwnd_combo_connectto, buf);
	}
}


// I
void WItalk2::combo_connectto_destroy(void)
{
	hwnd_combo_connectto = NULL;

	if (hfont_combo_connectto) DeleteObject(hfont_combo_connectto);
	hfont_combo_connectto = NULL;

	hwnd_button_connectto = NULL;

	if (hbitmap_go) DeleteObject(hbitmap_go);
	hbitmap_go = NULL;

	hwnd_anim_connectto = NULL;

	if (himl_anim_connectto) ImageList_Destroy(himl_anim_connectto);
	himl_anim_connectto = NULL;

	if (hbrush_background) DeleteObject(hbrush_background);
	hbrush_background = NULL;
}


// TCY
void WItalk2::combo_connectto_resize(void)
{
	RECT rc, rc_buttons, rc_anim;
	toolbar->GetButtonRect(toolbar->GetButtonCount() - 1, &rc_buttons);
	int button_width = (rc_buttons.right - rc_buttons.left);
	int button_height = (rc_buttons.bottom - rc_buttons.top );
	GetClientRect(toolbar->Hwnd(), &rc);
	GetClientRect(hwnd_anim_connectto, &rc_anim);
	toolbar->GetButtonsRect(&rc_buttons);
	int height = ComboBox_GetItemHeight(hwnd_combo_connectto) + 6;
	int toolbar_height = rc.bottom;

	rc.left   = rc_buttons.right + 5;
	rc.right -= 12 + rc_anim.right + button_width;
	rc.top    = (toolbar_height - height) / 2;
	rc.bottom = rc.top + 256;
	MoveWindow(hwnd_combo_connectto, &rc, TRUE);

	rc.left   = rc.right + 5;
	rc.right  = rc.left + button_width;
	//c:^Ɉړ
	//rc.top    = rc_buttons.top;
	//rc.bottom = rc_buttons.bottom;
	rc.top    = (toolbar_height - button_height) / 2;
	rc.bottom = rc.top + button_height;
	MoveWindow(hwnd_button_connectto, &rc, TRUE);

	rc.left   = rc.right + 5;
	rc.right  = rc.left + rc_anim.right;
	rc.top    = (toolbar_height - rc_anim.bottom) / 2;
	rc.bottom = rc.top + rc_anim.bottom;
	MoveWindow(hwnd_anim_connectto, &rc, TRUE);
}


// ĕ`
void WItalk2::combo_connectto_redraw(void)
{
	InvalidateRect(hwnd_combo_connectto, NULL, TRUE);
	UpdateWindow(hwnd_combo_connectto);
}


// tHg̐ݒ
void WItalk2::combo_connectto_set_font(void)
{
	_ASSERT( m_pProfileManager );
	LOGFONT lf;
	m_pProfileManager->Read("Font", lf, lgWindows::LoadString(rStringDefaultLogFont));
	gbl_lf = lf;
	if (hfont_combo_connectto) DeleteObject(hfont_combo_connectto);
	hfont_combo_connectto = CreateFontIndirect(&lf);
	SetWindowFont(hwnd_combo_connectto, hfont_combo_connectto, TRUE);

	combo_connectto_resize();
}


// tH[JX̐ݒ
void WItalk2::combo_connectto_setfocus(void)
{
	SetFocus(hwnd_combo_connectto);
}


// ڑ
void WItalk2::combo_connectto_connected(void)
{
	_ASSERT( m_pProfileManager );
	lgcAnimation_End(hwnd_anim_connectto);
	statusbar->SetDefaultText(NULL);

	// WXg
	// Waffle 0.2.0e: ۑASYύX
	char buf_defserver[BUFSIZE];
	GetWindowText(hwnd_combo_connectto, buf_defserver, sizeof(buf_defserver));
	/* ComboBox_FindString RԂۂ
	   Ƃ "akane.hakusan.tsg.ne.jp"  "akane.hakusan.tsg.ne.jp:20000" Ƀ}b`悤Ȃ͎̂dlH */
	//int server_i = ComboBox_FindString(hwnd_combo_connectto, -1, buf_defserver);
	/* ̂̂R{{bNXrł */
	int	deletedItems = 0;
	{
		char	buf[BUFSIZE];
		for (int i = 0; i < 64; ){
			if (CB_ERR == ComboBox_GetLBText(hwnd_combo_connectto, i, buf)) break;
			if (_mbsicmp(buf, buf_defserver) == 0){
				ComboBox_DeleteString(hwnd_combo_connectto, i);
				deletedItems++;
			} else {
				i++;
			}
		}
	}
	/* R{{bNX̐擪ɒǉ */
	ComboBox_InsertString(hwnd_combo_connectto, 0, buf_defserver);
	int index = 0;
	char buf[BUFSIZE];
	/* R{{bNX̓eWXgɏo */
	int	lastIndex;
	for (int i = 0; i < 64; i++) {	// Waffle 0.1.11: B΍
		if (CB_ERR == ComboBox_GetLBText(hwnd_combo_connectto, i, buf)){ lastIndex = i-1; break; }
		char name[BUFSIZE];
		sprintf(name, "ItalkServer%d", index++);
		m_pProfileManager->Write(name, buf);
	}
	/* WXg]荀ڂ폜 */
	for (; index < 64; index++){
		char	name[BUFSIZE];
		sprintf(name, "ItalkServer%d", index);
		if (!m_pProfileManager->Delete(name)) break;
	}
	/* R{{bNXɐVftHgT[oZbg */
	SetWindowText(hwnd_combo_connectto, buf_defserver);

	reset_focus();
}


// ڑs
void WItalk2::combo_connectto_failed_to_connect(void)
{
	lgcAnimation_End(hwnd_anim_connectto);
	statusbar->SetDefaultText(NULL);
}


// ڑI
void WItalk2::combo_connectto_closed(void)
{
	lgcAnimation_End(hwnd_anim_connectto);
	statusbar->SetDefaultText(NULL);

	sent_handle = false;					// Waffle 0.1.11
}


// G[
void WItalk2::combo_connectto_error(void)
{
	statusbar->SetDefaultText(NULL);
}


// tH[JXĂ邩ǂ
BOOL WItalk2::combo_connectto_is_focused(void)
{
	HWND hwnd_focus = GetFocus();
	while (hwnd_focus != hwnd_combo_connectto) if (!(hwnd_focus = GetParent(hwnd_focus))) return FALSE;
	return TRUE;
}


// tH[JX hwnd_combo_connectto ɂƂ̂ݐڑ
// handlehostport  NULL łȂ΁AtH[JXɊ֌WȂڑ
BOOL WItalk2::combo_connectto_connect(const char *handlehostport)
{
	_ASSERT( m_pProfileManager );
	if (hwnd_combo_connectto && !combo_connectto_is_focused()) return FALSE;

	// Waffle 0.2.0b: "connect=" Ă
	if (handlehostport && strlen(handlehostport) > 8 && strncmp(handlehostport, "connect=", 8) == 0) handlehostport += 8;

	wchar_t wcsbuf[BUFSIZE];
	char mbsbuf[BUFSIZE];

	// nh
	m_pProfileManager->Read("Handle", wcsbuf, sizeof(wcsbuf), L"");
	handle = wstring( wcsbuf );

	// zXg
	if (handlehostport) strcpy(mbsbuf, handlehostport); else GetWindowText(hwnd_combo_connectto, mbsbuf, sizeof(mbsbuf));
	char *host;
	u_short port;
	if (ic.GetHostPort(mbsbuf, host, port, 12345)) {
		char *at = _mbschr(host, '@');
		if (at) {
			host[(int)(at - host)] = '\0';
			at++;
			mbstowcs(wcsbuf, host, (int)(at - host) + 1);
			handle = wstring( wcsbuf );
			host = at;
		}

		// modified by TYM
		//  host  port oĂ
		if ( szItalkHost ) delete [] szItalkHost;
		szItalkHost = new char[strlen(host)+1];
		strcpy(szItalkHost,host);
		uItalkPort = port;

		ic.Disconnect();
		ic.ConnectTo(host, port);

		lgcAnimation_Start(hwnd_anim_connectto, 200);

		char buf[BUFSIZE];
		sprintf(buf, LoadString(rStringConnecting), host, (int)port);
		statusbar->SetDefaultText(buf);
	} else {
		show_error_message(LoadString(rStringNoHostname));
	}
	return TRUE;
}


// c[o[TuNX
void WItalk2::subclass_wmCtlColor(HWND hwnd)
{
	SetProp(hwnd, "ORIGINAL_WNDPROC", SubclassWindow(hwnd, ForwardWmCtlColorWndProc));
}


LRESULT CALLBACK WItalk2::ForwardWmCtlColorWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_CTLCOLOREDIT) return SendMessage(GetParent(hwnd), message, wParam, lParam);

	WNDPROC wndproc = (WNDPROC)GetProp(hwnd, "ORIGINAL_WNDPROC");
	if (message == WM_NCDESTROY) RemoveProp(hwnd, "ORIGINAL_WNDPROC");
	if (wndproc) {
		return CallWindowProc((WNDPROC)wndproc, hwnd, message, wParam, lParam);
	} else {
		return DefWindowProc(hwnd, message, wParam, lParam);
	}
}
