// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItlak2Splitbar.cxx

#include	<winsock2.h>
#include <crtdbg.h>

#include "WItalk2.h"
#include "ProfileManager.h"
//  1
void WItalk2::splitbar_create(void)
{
  hwnd_splitbar = CreateWindowEx(NULL, WC_lgcSplitbar, NULL, WS_CHILD | WS_VISIBLE | SBS_HORZ,
								 0, 0, 300, 300, Hwnd(), NULL, lgWindows::hInst(), NULL);
  _ASSERT(hwnd_splitbar);
#if 0
  hwnd_splitbar_log = CreateWindowEx(NULL, WC_lgcSplitbar, NULL, WS_CHILD | WS_VISIBLE | SBS_HORZ,
									 0, 0, 300, 300, hwnd_splitbar, NULL, lgWindows::hInst(), NULL);
  _ASSERT(hwnd_splitbar_log);
  hwnd_splitbar_public_private = CreateWindowEx(NULL, WC_lgcSplitbar, NULL, WS_CHILD | WS_VISIBLE | SBS_HORZ,
												0, 0, 300, 300, hwnd_splitbar_log, NULL, lgWindows::hInst(), NULL);
  _ASSERT(hwnd_splitbar_public_private);
#endif
}


//  2
void WItalk2::splitbar_init_after_iv(void)
{
#if 0
  lgcSplitbar_SetChild(hwnd_splitbar, 0, iv_input->Re.Hwnd());
  lgcSplitbar_SetChild(hwnd_splitbar, 1, hwnd_splitbar_log);
  lgcSplitbar_SetTooltips(hwnd_splitbar, hwnd_tooltip);

  lgcSplitbar_SetChild(hwnd_splitbar_log, 0, iv_log->Re.Hwnd());
  lgcSplitbar_SetChild(hwnd_splitbar_log, 1, hwnd_splitbar_public_private);
  lgcSplitbar_SetTooltips(hwnd_splitbar_log, hwnd_tooltip);

  lgcSplitbar_SetChild(hwnd_splitbar_public_private, 0,
		       iv_log_public->Re.Hwnd());
  lgcSplitbar_SetChild(hwnd_splitbar_public_private, 1,
		       iv_log_private->Re.Hwnd());
  lgcSplitbar_SetTooltips(hwnd_splitbar_public_private, hwnd_tooltip);
#else
  lgcSplitbar_SetChild(hwnd_splitbar, 0, iv_input->Re.Hwnd());
  lgcSplitbar_SetChild(hwnd_splitbar, 1, iv_log_public->Re.Hwnd());
  lgcSplitbar_SetTooltips(hwnd_splitbar, hwnd_tooltip);
#endif
}


//  3
void WItalk2::splitbar_read_registry(void)
{
	_ASSERT( m_pProfileManager );
	int value;
	m_pProfileManager->Read("SplitbarMain", value, 0x45b);
	lgcSplitbar_SetLayout(hwnd_splitbar, value);
	m_pProfileManager->Read("SplitbarLog", value, 0x4d);
	lgcSplitbar_SetLayout(hwnd_splitbar_log, value);
	m_pProfileManager->Read("SplitbarLogPP", value, 0x20d);
	lgcSplitbar_SetLayout(hwnd_splitbar_public_private, value);
}


// Ƃ܂
void WItalk2::splitbar_destroy(void)
{
	_ASSERT( m_pProfileManager );
#if 0
  m_pProfileManager->Write("SplitbarMain" ,
		 lgcSplitbar_GetLayout(hwnd_splitbar,
				       iv_input->Re.Hwnd(),
				       hwnd_splitbar_log));
  m_pProfileManager->Write("SplitbarLog",
		 lgcSplitbar_GetLayout(hwnd_splitbar_log,
				       iv_log->Re.Hwnd(),
				       hwnd_splitbar_public_private));
  m_pProfileManager->Write("SplitbarLogPP",
		 lgcSplitbar_GetLayout(hwnd_splitbar_public_private,
				       iv_log_public->Re.Hwnd(),
				       iv_log_private->Re.Hwnd()));
#else
  m_pProfileManager->Write("SplitbarMain" ,
		 lgcSplitbar_GetLayout(hwnd_splitbar,
				       iv_input->Re.Hwnd(),
				       iv_log_public->Re.Hwnd()));
#endif
  hwnd_splitbar = NULL;
  hwnd_splitbar_log = NULL;
  hwnd_splitbar_public_private = NULL;
}


// TCY
void WItalk2::splitbar_resize(void)
{
  RECT rc_url;	     GetChildWindowRect(hwnd_url, &rc_url);
  RECT rc_toolbar;   GetChildWindowRect(toolbar->Hwnd(), &rc_toolbar);
  RECT rc_statusbar; GetChildWindowRect(statusbar->Hwnd(), &rc_statusbar);
  RECT rc;	     GetClientRect(Hwnd(), &rc);
  RECT rc_splitbar = rc;

	// modified by sept
	/*
  rc_splitbar.top     = rc_toolbar.bottom + 2 + TOOLBAR_MAGIC_NUMBER;
  rc_splitbar.left    = 2;
  rc_splitbar.right  -= 2;
  rc_splitbar.bottom  = rc_statusbar.top - 2;
	*/
	rc_splitbar.top     = rc_toolbar.bottom + 0 + TOOLBAR_MAGIC_NUMBER;
	rc_splitbar.left    = 0;
	rc_splitbar.right  -= 0;
	rc_splitbar.bottom  = rc_statusbar.top - 0;

  if (IsWindowVisible(hwnd_url))
    rc_splitbar.top += rc_url.bottom - rc_url.top;

  MoveWindow(hwnd_splitbar, &rc_splitbar, TRUE);
}
