/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgSocket.cxx


#include	<winsock2.h>
#include	<ws2tcpip.h>
#ifndef	IPPROTO_IPV6
//#include	<tpipv6.h>
#endif
#include	<crtdbg.h>

#include	"lgSocket.h"
#include	"resource.h"
#include	<process.h>
#include	"WItalk2.h"


// len ̏dvł(^^;


#define instance_count_GUID "{E723DB27-D2AC-11d0-8EA8-204C4F4F5020}"
#define WC_lgSocket "lgSocket"
#define WM_ConnectTo             (WM_APP + 100)
#define WM_Disconnect            (WM_APP + 101)
#define WM_CompleteGethostbyname (WM_APP + 102)
#define WM_WSAAsyncSelect        (WM_APP + 103)
#define WM_Write                 (WM_APP + 104)
#define WM_Read                  (WM_APP + 105)

// lgSocket ̃CX^X݂邩
int volatile lgSocket::instance_count;


// EBhEvVW
LRESULT CALLBACK lgSocket::lgSocketWndProc(HWND hwnd, UINT message,
					   WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass lgSocket
  switch (message)
  {
    case WM_CREATE:
      SetWindowLongPtr(hwnd, GWLP_USERDATA, (LONG_PTR)(((CREATESTRUCT *)lParam)->lpCreateParams));
      return 0;
    case WM_DESTROY:
      PostQuitMessage(0);
      // fall through
    case WM_Disconnect:
      return lgwc->disconnect();
    case WM_ConnectTo:
      return lgwc->connect_to();
    case WM_CompleteGethostbyname:
      return lgwc->complete_gethostbyname(WSAGETASYNCERROR(lParam));
    case WM_WSAAsyncSelect:
      return lgwc->wsa_async_select(WSAGETSELECTEVENT(lParam),
				    WSAGETSELECTERROR(lParam));
    case WM_Write:
      return lgwc->write((char *)lParam, (int)wParam);
    case WM_Read:
      return lgwc->read((char *)lParam, (int)wParam);
  }
  return DefWindowProc(hwnd, message, wParam, lParam);
}


// thread bZ[W[v
void lgSocket::message_loop(void *This)
{
	initLocale();
	((lgSocket *)This)->hwnd = CreateWindowEx(NULL, WC_lgSocket, "lgSocketWindow", 0, 0, 0, 1, 1, NULL, NULL, lgWindows::hInst(), This);
	_ASSERT(((lgSocket*)This)->hwnd);
	MSG msg;
	while (0 < GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}


// ڑ̏
int lgSocket::connect_to(void)
{
	if (IsValid()) disconnect();

	_ASSERT(hostname); if (!hostname) return FALSE;
	if (!hostname) return false;
	if (/*connect6and4*/connect4and6((char*)hostname)) return true;
	if (!hostname) return false;

	WaitForSingleObject(mutex_gethostbyname, INFINITE);
	hgethostbyname = WSAAsyncGetHostByName(hwnd, WM_CompleteGethostbyname, (char*)hostname, server_host_buf, sizeof(server_host_buf));
	int does_failed = !hgethostbyname;
	ReleaseMutex(mutex_gethostbyname);
	if (does_failed) {
		int wsaerrno = WSAGetLastError();
		disconnect();
		FailedToConnect(wsaerrno);
		return FALSE;
	}
	return TRUE;
}


// zXg̎擾̊
int lgSocket::complete_gethostbyname(int wsaerrno)
{
	WaitForSingleObject(mutex_gethostbyname, INFINITE);
	if (hgethostbyname) {
		hgethostbyname = NULL;
		ReleaseMutex(mutex_gethostbyname);

		if (wsaerrno == 0)
			return connect(((struct in_addr *)(((struct hostent *)server_host_buf)->h_addr))->s_addr);
		int wsaerrno = WSAGetLastError();
		disconnect();
		FailedToConnect(wsaerrno);
	} else {
		ReleaseMutex(mutex_gethostbyname);
		disconnect();
	}
	return 0;
}


//
// IPv4 Ŏۂɐڑ
//
BOOL lgSocket::connect(u_long addr)
{
	sockaddr_in server_addr;
	ZeroMemory((char *)&server_addr, sizeof(server_addr));

	server_addr.sin_family      = AF_INET;
	server_addr.sin_port        = htons(port);
	server_addr.sin_addr.s_addr = addr;

	// socket 쐬
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) goto error;

	// connect
	if (WSAAsyncSelect(s, hwnd, WM_WSAAsyncSelect, FD_CONNECT) == SOCKET_ERROR) goto error;
	if (::connect(s, (struct sockaddr *)&server_addr, sizeof(server_addr)) == SOCKET_ERROR)
		if (WSAGetLastError() != WSAEWOULDBLOCK)
			goto error;

	return TRUE;

error:
	int wsaerrno = WSAGetLastError();
	disconnect();
	FailedToConnect(wsaerrno);
	return FALSE;
}


//
// IPv4/IPv6 Ŏۂɐڑ (IPv4D)
//
BOOL lgSocket::connect4and6(volatile char* hostname)
{
	addrinfo far*	ainfo;
	const char*		hname = (const char*)(hostname);
	char			pname[NI_MAXSERV];
	sprintf(pname, "%d", port);
	struct	addrinfo	hints;
	memset(&hints, 0, sizeof(hints));

	hints.ai_family = AF_INET;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	if (getaddrinfo(hname, pname, &hints, &ainfo)) {
		hints.ai_family = AF_INET6;
		if (getaddrinfo(hname, pname, &hints, &ainfo)) goto error;
		// IPv6 socket 쐬
		if ((s = socket(AF_INET6, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) goto error;
	} else {
		if ((s = socket(AF_INET,  SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) goto error;
	}

	// connect
	if (WSAAsyncSelect(s, hwnd, WM_WSAAsyncSelect, FD_CONNECT) == SOCKET_ERROR) goto error;
	if (::connect(s, ainfo->ai_addr, ainfo->ai_addrlen) == SOCKET_ERROR)
		if (WSAGetLastError() != WSAEWOULDBLOCK)
			goto error;

	return TRUE;

error:

	int wsaerrno = WSAGetLastError();
	disconnect();
	FailedToConnect(wsaerrno);
	return FALSE;
}


//
// IPv4/IPv6 Ŏۂɐڑ (IPv6D)
//
BOOL lgSocket::connect6and4(volatile char* hostname)
{
	addrinfo far*	ainfo;
	const char*		hname = (const char*)(hostname);
	char			pname[NI_MAXSERV];
	sprintf(pname, "%d", port);
	struct	addrinfo	hints;
	memset(&hints, 0, sizeof(hints));

	hints.ai_family = AF_INET6;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	if (getaddrinfo(hname, pname, &hints, &ainfo)) {
		hints.ai_family = AF_INET;
		if (getaddrinfo(hname, pname, &hints, &ainfo)) goto error;
		// IPv4 socket 쐬
		if ((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) goto error;
	} else {
		if ((s = socket(AF_INET6,  SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) goto error;
	}

	// connect
	if (WSAAsyncSelect(s, hwnd, WM_WSAAsyncSelect, FD_CONNECT) == SOCKET_ERROR) goto error;
	if (::connect(s, ainfo->ai_addr, ainfo->ai_addrlen) == SOCKET_ERROR)
		if (WSAGetLastError() != WSAEWOULDBLOCK)
			goto error;

	return TRUE;

error:

	int wsaerrno = WSAGetLastError();
	disconnect();
	FailedToConnect(wsaerrno);
	return FALSE;
}


// ۂɐؒf
BOOL lgSocket::disconnect(void)
{
  WaitForSingleObject(mutex_disconnect, INFINITE);
  
  BOOL r = FALSE;
  
  if (hgethostbyname)
  {
    WSACancelAsyncRequest(hgethostbyname);
    r = TRUE;
    hgethostbyname = NULL;
  }
  
  if (IsValid())
  {
    WSAAsyncSelect(s, hwnd, 0, 0);
    closesocket(s);
    s = INVALID_SOCKET;
    r = TRUE;
  }
  
  WaitForSingleObject(mutex_hostname_port, INFINITE);
  if (hostname)
    delete_string((char *&)hostname);
  ReleaseMutex(mutex_hostname_port);
  
  ReleaseMutex(mutex_disconnect);
  
  if (r)
    ConnectionClosed();
  
  return r;
}


// \PbgCxg
int lgSocket::wsa_async_select(int wsaevent, int wsaerrno)
{
  if (wsaerrno)
  {
    disconnect();
    if (wsaevent == FD_CONNECT)
      FailedToConnect(wsaerrno);
    else
      Error(wsaerrno);
    return 0;
  }
  
  switch (wsaevent)
  {
    case FD_CONNECT:
      if (WSAAsyncSelect(s, hwnd, WM_WSAAsyncSelect, FD_READ | FD_CLOSE) ==
	  SOCKET_ERROR)
      {
	int wsaerrno = WSAGetLastError();
	disconnect();
	FailedToConnect(wsaerrno);
	return 0;
      }
      Connected();
      return 0;
      
    case FD_CLOSE:
      disconnect();
      Disconnected();
      return 0;
      
    case FD_READ:
      while (!DataArrived())
	Sleep(10);
      return 0;
      
    default:
    {
      int wsaerrno = WSAGetLastError();
      disconnect();
      Error(wsaerrno);
      return 0;
    }
  }
  return 0;
}


// \Pbgɏ
int lgSocket::write(char *buf, int sizeof_buf)
{
	int len = send(s, buf, sizeof_buf, 0);
	if (len == SOCKET_ERROR) {
		int wsaerrno = WSAGetLastError();
		disconnect();
		Error(wsaerrno);
	}
	return len;
}


// \Pbgǂ
int lgSocket::read(char *buf, int sizeof_buf)
{
	if (!IsValid()) return -1;
	int len = recv(s, buf, sizeof_buf, 0);
	if (len == SOCKET_ERROR) {
		int wsaerrno = WSAGetLastError();
		disconnect();
		Error(wsaerrno);
	}
	return len;
}


// RXgN^
lgSocket::lgSocket(void)
  : s(INVALID_SOCKET),
    hwnd(NULL),
    hostname(NULL),
    port(0),
    mutex_hostname_port(CreateMutex(NULL, FALSE, NULL)),
    hgethostbyname(NULL),
    mutex_gethostbyname(CreateMutex(NULL, FALSE, NULL)),
    mutex_connect_to(CreateMutex(NULL, FALSE, NULL)),
    mutex_disconnect(CreateMutex(NULL, FALSE, NULL))
{
  HANDLE mutex_instance_count = CreateMutex(NULL, FALSE, instance_count_GUID);
  WaitForSingleObject(mutex_instance_count, INFINITE);
  
  if (instance_count == 0)
  {
    // winsock ̏
    WSADATA wsaData;
    WSAStartup(MAKEWORD(2, 2), &wsaData); // TODO: sȂƉ
    
    // lgSocket p WndClass ̓o^
    WNDCLASSEX wc;
	wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = lgSocketWndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = lgWindows::hInst();
    wc.hIcon         = NULL;
	wc.hIconSm       = NULL;
    wc.hCursor       = NULL;
    wc.hbrBackground = NULL;
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = WC_lgSocket;
    ATOM rrcex = RegisterClassEx(&wc);
	_ASSERT(rrcex);
  }
  instance_count++;
  
  ReleaseMutex(mutex_instance_count);
  CloseHandle(mutex_instance_count);
  
  /*registerThread(*/_beginthread(message_loop, 0, this)/*)*/;
  
  while (!hwnd)
    Sleep(10);
}


// fXgN^
lgSocket::~lgSocket()
{
  HANDLE mutex_instance_count = CreateMutex(NULL, FALSE, instance_count_GUID);
  WaitForSingleObject(mutex_instance_count, INFINITE);
  
  instance_count--;
  if (instance_count == 0)
  {
    WSACleanup();
    BOOL ruc = UnregisterClass(WC_lgSocket, lgWindows::hInst());
	_ASSERT(ruc);
  }
  
  ReleaseMutex(mutex_instance_count);
  CloseHandle(mutex_instance_count);
  
  DestroyWindow(hwnd);
  
  CloseHandle(mutex_hostname_port);
  CloseHandle(mutex_gethostbyname);
  CloseHandle(mutex_connect_to);
  CloseHandle(mutex_disconnect);
}


// ڑv
BOOL lgSocket::ConnectTo(const char *_hostname, u_short port_default)
{
  WaitForSingleObject(mutex_connect_to, INFINITE);
  
  if (_hostname)
  {
    char buf[BUFSIZE];
    strcpy(buf, _hostname);
    char *__hostname;
    u_short __port;
    if (GetHostPort(buf, __hostname, __port, port_default))
    {
      if (IsValid())
	Disconnect();
      
      WaitForSingleObject(mutex_hostname_port, INFINITE);
      replace_string((char *&)hostname, __hostname);
      port = __port;
      ReleaseMutex(mutex_hostname_port);
      
      PostMessage(hwnd, WM_ConnectTo, 0, 0);
    }
  }
  
  ReleaseMutex(mutex_connect_to);
  
  return TRUE;
}


// ؒfv
BOOL lgSocket::Disconnect(void)
{
  return SendMessage(hwnd, WM_Disconnect, 0, 0);
}


// Lǂ
BOOL lgSocket::IsValid(void)
{
  return s != INVALID_SOCKET;
}


// ڑAłɐڑIĒʐMĂ
BOOL lgSocket::IsConnecting(void)
{
  return hgethostbyname || IsValid();
}


// SSL\Pbg܂͐\Pbgɏ
int lgSocket::Write(const char *buf, int sizeof_buf)
{
	if (sslMode) {
		return SSL_write(ssl, buf, sizeof_buf);
	} else {
		return SendMessage(hwnd, WM_Write, sizeof_buf, (LPARAM)buf);
	}
}


// SSL\Pbg܂͐\Pbgǂ
int lgSocket::Read(char *buf, int sizeof_buf)
{
	if (sslMode) {
		return SSL_read(ssl, buf, sizeof_buf);
	} else {
        return SendMessage(hwnd, WM_Read, sizeof_buf, (LPARAM)buf);
	}
}


// buf  sizeof_read_data ̑傫̃f[^܂܂œǂށBǂݍ
// Ɏs FALSEBǂݍ݂ɐ TRUEB 
// sizeof_read_data == sizeof_data ƂȂĂf[^̓ǂݍ݊B
BOOL lgSocket::ReadSizedData(char *buf, int sizeof_data,
				       int &sizeof_read_data)
{
  int len = Read((char *)(buf + sizeof_read_data),
		 sizeof_data - sizeof_read_data);
  if (len <= 0)
    return FALSE;
  sizeof_read_data += len;
  return TRUE;
}
  



// "HOSTNAME:PORT" zXgƃ|[gԍ𓾂 hostport ̓e͔j󂳂
BOOL lgSocket::GetHostPort(char *hostport, char *&hostname_r,
				     u_short &port_r, u_short port_default)
{
	if (!hostport || !(*hostport)) return false;
	if (*hostport == '[') {	// '[' ']'  IPv6 lAhX
		char*	rb = strchr(hostport, ']');
		if (!rb) return false;
		*rb = 0; hostname_r = hostport+1;
		rb++;
		if (!(*rb) || *rb != ':') {
			port_r = port_default;
		} else {
			port_r = (u_short)atoi(rb+1);
		}
		return true;
	} else {
		char*	fc = strchr(hostport, ':');
		if (fc) {
			fc = strchr(fc+1, ':');
			if (fc) {	// '[' ']'  IPv6 lAhXŊOČĂ΂ꂽ
				hostname_r = hostport; port_r = port_default;
				return true;
			}
		}
	}
	hostname_r = _mbstok(hostport, ": \t");
	if (!hostname_r)
		return FALSE;
	char *port = _mbstok(NULL, ": \t");
	if (port)
		port_r = (u_short)atoi(port);
	else
		port_r = port_default;
	return TRUE;
}

BOOL lgSocket::GetHostPort(wchar_t *hostport, wchar_t *&hostname_r,
				     u_short &port_r, u_short port_default)
{
  hostname_r = wcstok(hostport, L": \t");
  if (!hostname_r)
    return FALSE;
  wchar_t *port = wcstok(NULL, L": \t");
  if (port)
    port_r = (u_short)_wtoi(port);
  else
    port_r = port_default;
  return TRUE;
}


// G[̓e擾
const char *lgSocket::GetErrorMessage(int wsaerrno)
{
#define E(err) { err, #err }
  static const struct
  {
    int wsaerrno;
    int errstr;
  } errors[] = {
#define WSA(E) WSA##E, rStringWSA##E
    WSA(EACCES),         WSA(EADDRNOTAVAIL),    WSA(ENETRESET),
    WSA(ECONNABORTED),   WSA(EADDRINUSE),       WSA(ENETDOWN),
    WSA(ENETUNREACH),    WSA(ECONNRESET),       WSA(EISCONN), 
    WSA(ENOTCONN),       WSA(ESHUTDOWN),        WSA(ETIMEDOUT),  
    WSA(ECONNREFUSED),   WSA(SYSNOTREADY),      WSA(VERNOTSUPPORTED), 
    WSA(NOTINITIALISED), WSA(HOST_NOT_FOUND),   WSA(TRY_AGAIN), 
    WSA(NO_RECOVERY),
    
    WSA(EINTR),          WSA(EBADF),            WSA(EFAULT),
    WSA(EINVAL),         WSA(EMFILE),           WSA(EWOULDBLOCK),
    WSA(EINPROGRESS),    WSA(EALREADY),         WSA(ENOTSOCK),
    WSA(EDESTADDRREQ),   WSA(EMSGSIZE),         WSA(EPROTOTYPE),
    WSA(ENOPROTOOPT),    WSA(EPROTONOSUPPORT),  WSA(ESOCKTNOSUPPORT),
    WSA(EOPNOTSUPP),     WSA(EPFNOSUPPORT),     WSA(EAFNOSUPPORT),
    WSA(ENOBUFS),        WSA(ELOOP),            WSA(ENAMETOOLONG),
    WSA(EHOSTDOWN),      WSA(EHOSTUNREACH),     WSA(ENOTEMPTY),
    WSA(EPROCLIM),       WSA(EUSERS),           WSA(EDQUOT),
    WSA(ESTALE),         WSA(EREMOTE),          WSA(EDISCON),
    WSA(ETOOMANYREFS),   WSA(NO_DATA),          WSA(NO_ADDRESS),
#undef WSA
  };
  
  int errstr = 0;
  
  for (int i = 0; i < ArrayNum(errors); i++)
    if (wsaerrno == errors[i].wsaerrno)
    {
      errstr = errors[i].errstr;
      break;
    }

  __declspec(thread) static char buf[BUFSIZE];
  wsprintf(buf, "ERROR %d: ", wsaerrno);
  int len = strlen(buf);
  if (errstr)
    ::LoadString(lgWindows::lg_hInst(), errstr, buf + len, sizeof(buf) - len);
  else
    strcpy(buf + len, "Unknown Error");
  
  return buf;
}


// G[̓e\
void lgSocket::ShowErrorMessage(HWND hwnd, const char *message,
					  const char *title, int wsaerrno)
{
  const char *error_message = GetErrorMessage(wsaerrno);
  char buf[BUFSIZE];
  wsprintf(buf, "%s\n%s", error_message, message);
  char _title[BUFSIZE];
  if (!title)
  {
    GetWindowText(hwnd, _title, sizeof(_title));
    title = _title;
  }
  MessageBox(hwnd, buf, title, MB_ICONSTOP);
}

int		lgSocket::registeredSocketWindows = 0;
HWND	lgSocket::socketWindowList[256];

// \PbgpEBhEnho^
void lgSocket::registerSocketWindow(HWND hwnd)
{
	if (registeredSocketWindows < 256) socketWindowList[registeredSocketWindows++] = hwnd;
}

// \PbgpEBhEnhSĂɏIw߂𑗂
void lgSocket::bukkoroAllSocketWindow()
{
	for (int i = 0; i < registeredSocketWindows++; i++) DestroyWindow(socketWindowList[i]);
}
