/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgSocket.h


#pragma		once

#include	<winsock2.h>
#include	"lgWindows.h"

#include	<openssl/crypto.h>
#include	<openssl/x509.h>
#include	<openssl/ssl.h>
#include	<openssl/err.h>


class lgSocket
{
	// lgSocket ̃CX^X݂邩
	static int volatile instance_count;
	HANDLE mutex_instance_count;

	// \Pbg
	SOCKET volatile s;

	// lgSocket ŎgpEBhE
	volatile HWND hwnd;

	// ݐڑ̃zXgƃ|[g
	volatile char *hostname;
	volatile u_short port;
	HANDLE mutex_hostname_port;

	// WSAAsyncGetHostByName ŗp
	char server_host_buf[MAXGETHOSTSTRUCT];
	HANDLE hgethostbyname;
	HANDLE mutex_gethostbyname;

	// ̑
	HANDLE mutex_connect_to;
	HANDLE mutex_disconnect;

	// Waffle 0.2.0e: lgSocket ŎgpEBhẼEBhEnhꗗ
	static int	registeredSocketWindows;				// o^ĂEBhE̐
	static HWND	socketWindowList[256];					// 256 ȏ̓\PbgJȂłˁB

private:

	//  Thread Ŏs֐Q
	static void message_loop(void *This);				// thread bZ[W[v
	int connect_to(void);								// ڑ̏
	int complete_gethostbyname(int wsaerrno);			// zXg̎擾̊
	BOOL connect(u_long addr);							// IPv4 Ŏۂɐڑ
	BOOL connect4and6(volatile char* hostname);			// IPv4/IPv6 Ŏۂɐڑ (IPv4D)
	BOOL connect6and4(volatile char* hostname);			// IPv4/IPv6 Ŏۂɐڑ (IPv6D)
	BOOL disconnect(void);								// ۂɐؒf
	int wsa_async_select(int wsaevent, int wsaerrno);	// \PbgCxg
	int write(char *buf, int sizeof_buf);				// 
	int read (char *buf, int sizeof_buf);				// ǂ
	static LRESULT CALLBACK lgSocketWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

protected:
	
	// \ Thread ŎsR[obN֐Q
	virtual void Connected(void) = 0;					// ڑ
	virtual void FailedToConnect(int wsaerrno) = 0;		// ڑs
	virtual void Disconnected(void) = 0;				// 肩ؒfꂽ
	virtual void ConnectionClosed(void) = 0;			// \PbgN[Y
	virtual void Error(int wsaerrno) = 0;				// ڑsȊÕG[
	virtual BOOL DataArrived(void) = 0;					// f[^
	// f[^Ȃ TRUE Ԃ

public:

	// SSLReLXg
	SSL_CTX*	ctx;
	SSL*		ssl;
	bool		sslMode;

	// \ Thread Ŏs֐Q
	lgSocket(void);										// RXgN^
	virtual ~lgSocket();								// fXgN^
	BOOL ConnectTo(const char *_hostname, u_short port_default);   // ڑv
	BOOL Disconnect(void);								// ؒfv
	BOOL IsValid(void);									// Lǂ
	BOOL IsConnecting(void);							// ڑAłɐڑIĒʐMĂ

	// Waffle 0.2.0e: XbhFEpo֐Q
	static void registerSocketWindow(HWND hwnd);		// \PbgpEBhEnho^
	static void bukkoroAllSocketWindow();				// o^EBhE WM_QUIT Ԃ

	// ǂ Thread łsł֐Q
	int Write(const char *buf, int sizeof_buf);			// 
	int Read(char *buf, int sizeof_buf);				// ǂ

	// buf  sizeof_read_data ̑傫̃f[^܂܂œǂށBǂݍ
	// Ɏs FALSEBǂݍ݂ɐ TRUEB 
	// sizeof_read_data == sizeof_data ƂȂĂf[^̓ǂݍ݊B
	BOOL ReadSizedData(char *buf, int sizeof_data, int &sizeof_read_data);

	// "HOSTNAME:PORT" zXgƃ|[gԍ𓾂 hostport ̓e͔j󂳂
	static BOOL GetHostPort(char *hostport, char *&hostname_r, u_short &port_r, u_short port_default);
	static BOOL GetHostPort(wchar_t *hostport, wchar_t *&hostname_r, u_short &port_r, u_short port_default);

	// G[̓e擾
	static const char *GetErrorMessage(int wsaerrno);
	// G[̓e\
	static void ShowErrorMessage(HWND hwnd, const char *message, const char *title, int wsaerrno);

	// \PbgԂ
	SOCKET getSocket() { return s; }
};
