/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgString.h


#pragma	once


//#include	<varargs.h>
#include	"lgWindows.h"
#include	<string.h>
#include	<mbstring.h>
#include	"gnu/regex.h"


// length ̒̓̕obt@̊m
inline char *new_string(size_t length)
{
  return new char[length + 1];
}
inline wchar_t *new_wstring(size_t length)
{
  return new wchar_t[length + 1];
}


// strdup  new Ŏ
inline char *new_string(const char *str)
{
  if (!str)
    return NULL;
  char *n_str = new_string(strlen(str));
  strcpy(n_str, str);
  return n_str;
}

inline wchar_t *new_string(const wchar_t *str)
{
  if (!str)
    return NULL;
  wchar_t *n_str = new_wstring(wcslen(str));
  wcscpy(n_str, str);
  return n_str;
}


// new_string Ŋmۂ̂̍폜
inline void delete_string(char *&str)
{
  if (str != 0) delete [] str; // NULL `FbN͌dlKvȂ
  str = NULL;
}

inline void delete_string(wchar_t *&str)
{
  if (str != 0) delete [] str; // NULL `FbN͌dlKvȂ
  str = NULL;
}


// new_string Ŋmۂ̂폜āAVݒ
inline char *replace_string(char *&dest, const char *src)
{
  delete_string(dest);
  return dest = new_string(src);
}

inline wchar_t *replace_string(wchar_t *&dest, const wchar_t *src)
{
  delete_string(dest);
  return dest = new_string(src);
}


#define alloca_mbstowcs(wcs, mbs, len)                  \
(len = mbstowcs(NULL, mbs, strlen(mbs) + 1),            \
 wcs = (wchar_t *)_alloca((len + 1) * sizeof(wchar_t)), \
 mbstowcs(wcs, mbs, len + 1),                           \
 wcs)

#define alloca_wcstombs(mbs, wcs, len)       \
(len = wcstombs(NULL, wcs, wcslen(wcs) + 1), \
 mbs = (char *)_alloca(len + 1),             \
 wcstombs(mbs, wcs, len + 1),                \
 mbs)


extern string rprintf(const char* format, ...);


class lgString
{
public:
  // UNIX ṼChJ[h}b`O
  //   mbs1: mbs2 ̏WɊ܂܂邩ǂ𒲂ׂΏ
  //   mbs2: W
  //   case_sensitive: 啶ʂ邩ǂ
  // p:
  //   BOOL f = lgString::DoesMatch("hoehoe nexe", "ho?*hoe*");
  //   ̏ꍇ f  TRUE
  // Ԓl:
  //   return: mbs2 ̏W mbs1 ܂܂Ȃ (܂}b`) TRUE
  //   i_end_r: ̓}b`ꏊ̐擪̕
  //   c_end_r: ̓}b`ꏊ̍Ōւ̃|C^
  // l:
  //   mbs1  mbs2 ɑOv̂Ƃ TRUE
  static BOOL DoesMatch(const char *mbs1, const char *mbs2,
			BOOL case_sensitive = TRUE)
  {
    int i_end_r;
    char *c_end_r;
    return DoesMatch(mbs1, mbs2, i_end_r, c_end_r, case_sensitive);
  }
  static BOOL DoesMatch(const wchar_t *wcs1, const wchar_t *wcs2,
			BOOL case_sensitive = TRUE)
  {
    int i_end_r;
    wchar_t *c_end_r;
    return DoesMatch(wcs1, wcs2, i_end_r, c_end_r, case_sensitive);
  }
  
  static BOOL DoesMatch(const char *mbs1, const char *mbs2, int &i_end_r,
			BOOL case_sensitive = TRUE)
  {
    char *c_end_r;
    return DoesMatch(mbs1, mbs2, i_end_r, c_end_r, case_sensitive);
  }
  static BOOL DoesMatch(const wchar_t *wcs1, const wchar_t *wcs2, int &i_end_r,
			BOOL case_sensitive = TRUE)
  {
    wchar_t *c_end_r;
    return DoesMatch(wcs1, wcs2, i_end_r, c_end_r, case_sensitive);
  }
  
  static BOOL DoesMatch(const char *mbs1, const char *mbs2,
			char *&c_end_r, BOOL case_sensitive = TRUE)
  {
    int i_end_r;
    return DoesMatch(mbs1, mbs2, i_end_r, c_end_r, case_sensitive);
  }
  static BOOL DoesMatch(const wchar_t *wcs1, const wchar_t *wcs2,
			wchar_t *&c_end_r, BOOL case_sensitive = TRUE)
  {
    int i_end_r;
    return DoesMatch(wcs1, wcs2, i_end_r, c_end_r, case_sensitive);
  }
  
  static BOOL DoesMatch(const char *mbs1, const char *mbs2,
				  int &i_end_r, char *&c_end_r,
				  BOOL case_sensitive = TRUE);
  static BOOL DoesMatch(const wchar_t *wcs1, const wchar_t *wcs2,
				  int &i_end_r, wchar_t *&c_end_r,
				  BOOL case_sensitive = TRUE);
  
  //
  // POSIX K\Cu (GNU glibc R) gp֐
  //
  static bool match(const char* mbs, const char* pattern, int cflags = 0);
  static bool match(const wchar_t* wcs, const char* pattern, int cflags = 0);
  static bool match(const wchar_t* wcs, const wchar_t* pattern, int cflags = 0);

  // R[hϊ 
  
  // 1ϊ
  static void sjisc2eucc(BYTE *euc_jp, const BYTE *sjis);
  // ϊ
  static int sjis2euc(BYTE *euc_jp, const BYTE *sjis,
				BOOL does_convert_crlf2lf = TRUE);
  static int sjis2euc(char *euc_jp, const char *sjis,
		      BOOL does_convert_crlf2lf = TRUE)
  { return sjis2euc((BYTE *)euc_jp, (BYTE *)sjis, does_convert_crlf2lf); }
  static int uni2euc(BYTE *euc_jp, const wchar_t *uni,
			       BOOL does_convert_crlf2lf = TRUE);
  static int uni2euc(char *euc_jp, const wchar_t *uni,
			       BOOL does_convert_crlf2lf = TRUE)
  { return uni2euc((BYTE *)euc_jp, uni, does_convert_crlf2lf); }
  
  // 1ϊ
  static void eucc2sjisc(BYTE *sjis, const BYTE *euc_jp);
  // ϊ
  static int euc2sjis(BYTE *sjis, const BYTE *euc_jp,
				BOOL does_convert_lf2crlf = TRUE);
  static int euc2sjis(char *sjis, const char *euc_jp,
		      BOOL does_convert_lf2crlf = TRUE)
  { return euc2sjis((BYTE *)sjis, (BYTE *)euc_jp, does_convert_lf2crlf); }
  static int euc2uni(wchar_t *uni, const BYTE *euc_jp,
			       BOOL does_convert_lf2crlf = TRUE);
  static int euc2uni(wchar_t *uni, const char *euc_jp,
			       BOOL does_convert_lf2crlf = TRUE)
  { return euc2uni(uni, (const BYTE *)euc_jp, does_convert_lf2crlf); }
  
  // SJIS ǂ
  static BOOL IsSJIS(const char *str);
  
  // str 񒆂 from ꂽ to ɒu
  static char *ReplaceChar(char *str, char to = '\0',
				     char from = '|');
  
  // Xy[X (' ',  '\t', '\r', '\n') ΂
  static char *SkipSpace(const char *str);
  static wchar_t *SkipSpace(const wchar_t *str);
  
  //  ('0'`'9') ΂
  static char *SkipNumber(const char *str);
  static wchar_t *SkipNumber(const wchar_t *str);
  
  // URL ɌƂ؂o
  static wchar_t *GetURL(wchar_t *url, int lengthof_url,
				   const wchar_t *wcs);
  static char *GetURL(char *url, int sizeof_url, const char *mbs);
  
  // _mbsstr ̑啶ʂȂo[W
  static BYTE *_mbsistr(const BYTE *mbs1, const BYTE *mbs2);
};


// cstrlen("HOGE") Ƃ悤ɎgBcstrlen(str) ͂߁B
#define cstrlen(str) (sizeof(str) - 1)

// }`oCg֐
inline char *_mbschr(const char *mbs1, int mbc2)
{
  return (char *)_mbschr ((const BYTE *)(mbs1), mbc2);
}

inline char *_mbsrchr(const char *mbs1, int mbc2)
{
  return (char *)_mbsrchr((const BYTE *)(mbs1), mbc2);
}

inline char *_mbsinc(const char *mbs1)
{
  return (char *)_mbsinc((const BYTE *)(mbs1));
}

inline char *_mbstok(char *mbs1, const char *mbs2)
{
  return (char *)_mbstok ((BYTE *)(mbs1), (const BYTE *)(mbs2));
}

inline char *_mbsstr(const char *mbs1, const char *mbs2)
{
  return (char *)_mbsstr ((const BYTE *)(mbs1), (const BYTE *)(mbs2));
}

inline char *_mbsistr(const char *mbs1, const char *mbs2)
{
  return (char *)lgString::_mbsistr((const BYTE *)(mbs1),
				    (const BYTE *)(mbs2));
}

inline char *_mbspbrk(const char *mbs1, const char *mbs2)
{
  return (char *)_mbspbrk((const BYTE *)(mbs1), (const BYTE *)(mbs2));
}

// }`oCgr֐
inline int _mbscmp(const char *mbs1, const char *mbs2)
{
  return _mbscmp((const BYTE *)(mbs1), (const BYTE *)(mbs2));
}

inline BOOL _mbsequal(const char *mbs1, const char *mbs2)
{
  return (BOOL)(_mbscmp(mbs1, mbs2) == 0);
}

inline int _mbsicmp(const char *mbs1, const char *mbs2)
{
  return _mbsicmp((const BYTE *)(mbs1), (const BYTE *)(mbs2));
}

inline BOOL _mbsiequal(const char *mbs1, const char *mbs2)
{
  return (BOOL)(_mbsicmp(mbs1, mbs2) == 0);
}

// }`oCg֐
inline size_t _mbclen(const char *mbs1)
{
  return _mbclen((const BYTE *)mbs1);
}

inline BOOL _mbcequal(const char *mbs1, const char *mbs2)
{
  return ((_mbclen(mbs1) == 1 && _mbclen(mbs2) == 1 &&
	   mbs1[0] == mbs2[0]) ||
          (_mbclen(mbs1) == 2 && _mbclen(mbs2) == 2 &&
	   mbs1[0] == mbs2[0] && mbs1[1] == mbs2[1]));
}

inline BOOL _mbciequal(const char *mbs1, const char *mbs2)
{
  return ((_mbclen(mbs1) == 1 && _mbclen(mbs2) == 1 &&
	   tolower(mbs1[0]) == tolower(mbs2[0])) ||
          (_mbclen(mbs1) == 2 && _mbclen(mbs2) == 2 &&
	   mbs1[0] == mbs2[0] && mbs1[1] == mbs2[1]));
}

// Ch֐
inline BOOL wcsequal(const wchar_t *wcs1, const wchar_t *wcs2)
{
  return wcscmp(wcs1, wcs2) == 0;
}

inline BOOL wcsiequal(const wchar_t *wcs1, const wchar_t *wcs2)
{
  return _wcsicmp(wcs1, wcs2) == 0;
}
