/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgWindow.cxx


#include "lgWindows.h"
#include "resource.h"


// ̑


// Window ʒu܂ňړ
RECT lgWindow::MoveWindowVisible(RECT rc)
{
	RECT drc;
	GetClientRect(GetDesktopWindow(), &drc);
	if (drc.right < rc.right) {
		rc.left -= rc.right - drc.right;
		rc.right = drc.right;
	}
	if (rc.left < 0) {
		rc.right += -rc.left;
		rc.left   = 0;
	}
	if (drc.bottom < rc.bottom) {
		rc.top   -= rc.bottom - drc.bottom;
		rc.bottom = drc.bottom;
	}
	if (rc.top < 0) {
		rc.bottom += -rc.top;
		rc.top     = 0;
	}
	return rc;
}


BOOL lgWindow::MoveWindowVisible(HWND hwnd)
{
	RECT rc;
	GetWindowRect(hwnd, &rc);
	rc = MoveWindowVisible(rc);
	lgWindow::MoveWindow(hwnd, &rc, TRUE);
	return TRUE;
}


// MoveWindow  RECT o[W
BOOL lgWindow::MoveWindow(HWND hwnd, RECT *rc, BOOL is_repaint)
{
  return ::MoveWindow(hwnd, rc->left, rc->top,
		      rc->right - rc->left, rc->bottom - rc->top, is_repaint);
}


// MoveWindow (TCY͕ύXȂ)
BOOL lgWindow::MoveWindow(HWND hwnd, int x, int y, BOOL is_repaint)
{
  if (is_repaint)
    return SetWindowPos(hwnd, NULL, x, y, 0, 0,
			SWP_NOACTIVATE | SWP_NOSIZE |
			SWP_NOREDRAW | SWP_NOZORDER);
  else
    return SetWindowPos(hwnd, NULL, x, y, 0, 0,
			SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER);
}


// ResizeWindow (ʒu͈ړȂ)
BOOL lgWindow::ResizeWindow(HWND hwnd, int w, int h, BOOL is_repaint)
{
  if (is_repaint)
    return SetWindowPos(hwnd, NULL, 0, 0, w, h,
			SWP_NOACTIVATE | SWP_NOMOVE |
			SWP_NOREDRAW | SWP_NOZORDER);
  else
    return SetWindowPos(hwnd, NULL, 0, 0, w, h,
			SWP_NOACTIVATE | SWP_NOMOVE
			| SWP_NOZORDER);
}


// eEBhE̒ł̃EBhȆ傫Ԃ
BOOL lgWindow::GetChildWindowRect(HWND hwnd, RECT *rc)
{
  if (!GetParent(hwnd))
    return FALSE;
  if (!GetWindowRect(hwnd, rc))
    return FALSE;
  POINT p;
  p.x = rc->left;
  p.y = rc->top;
  ScreenToClient(GetParent(hwnd), &p);
  rc->left = p.x;
  rc->top  = p.y;
  p.x = rc->right;
  p.y = rc->bottom;
  ScreenToClient(GetParent(hwnd), &p);
  rc->right = p.x;
  rc->bottom = p.y;
  return TRUE;
}


// Zbg
BOOL lgWindow::SetWindowText(HWND hwnd, int num)
{
  char buf[BUFSIZE];
  wsprintf(buf, "%d", num);
  return ::SetWindowText(hwnd, buf);
}


// Window Message


// R}h
int lgMainWindow::wmCommand(int notify_code, int id,
				      HWND hwnd_control)
{
  return default_return_value;
}


// ReLXgwv
int lgMainWindow::wmCommand_ContextHelp(void)
{
	wmCommand_Help();

  if (toolbar && context_help_id)
  {
    HELPINFO hi;
    hi.cbSize       = sizeof(hi);
    hi.iContextType = HELPINFO_MENUITEM;
    hi.iCtrlId      = toolbar->HitTest(toolbar_context_help_point.x,
				       toolbar_context_help_point.y);
    hi.hItemHandle  = toolbar->Hwnd();
    hi.dwContextId  = 0;
    hi.MousePos     = toolbar_context_help_point;
    return wmHelp(&hi);
  }
  return default_return_value;
}


// ReLXgwv
int lgMainWindow::wmCommand_Help(void)
{
  WinHelp(Hwnd(), help_filename, HELP_FINDER, 0);
  return default_return_value;
}


// ReLXgwvj[
int lgMainWindow::wmContextMenu(HWND _hwnd, int x, int y)
{
  if (!context_help_id)
    return default_return_value;
  
  if (toolbar)
  {
    RECT rc;
    GetWindowRect(toolbar->Hwnd(), &rc);
    if (rc.left <= x && x < rc.right &&
	rc.top  <= y && y < rc.bottom)
    {
      toolbar_context_help_point.x = x;
      toolbar_context_help_point.y = y;
      HMENU hmenu = LoadMenu(lgWindows::lg_hInst(), MAKEINTRESOURCE(rMenuContextHelpPopup));
      hmenu = GetSubMenu(hmenu, 0);
	  // Waffle 0.2.2beta6: Ɏx͂Ȃ΍
	  SetForegroundWindow(Hwnd());
      TrackPopupMenu(hmenu, 0, x, y, 0, Hwnd(), NULL);
	  PostMessage(Hwnd(), WM_NULL, 0, 0);
      return default_return_value;
    }
  }
  
  DWORD id = GetDlgCtrlID(_hwnd);
  for (int i = 0; context_help_id[i][0]; i++)
    if (id == context_help_id[i][0])
      WinHelp(_hwnd, help_filename, HELP_CONTEXTMENU, (DWORD)context_help_id);
  return default_return_value;
}


// I[i[h[
int lgMainWindow::wmDrawItem(int id, DRAWITEMSTRUCT *dis)
{
  if (statusbar)
    return statusbar->wmDrawItem(id, dis);
  return TRUE;
}


// wv
int lgMainWindow::wmHelp(HELPINFO *hi)
{
  if (help_filename && context_help_id)
    if (hi->iContextType == HELPINFO_WINDOW)
      WinHelp((HWND)hi->hItemHandle, help_filename,
	      HELP_WM_HELP, (DWORD)context_help_id);
    else
      for (int i = 0; context_help_id[i][0]; i++)
	if ((int)context_help_id[i][0] == hi->iCtrlId)
	{
	  WinHelp(Hwnd(), help_filename,
		  HELP_CONTEXTPOPUP, context_help_id[i][1]);
	  break;
	}
  return default_return_value;
}


// j[Iꂽ
int lgMainWindow::wmMenuSelect(UINT item, UINT flags, HMENU hmenu)
{
  if (statusbar)
  {
    char *message = NULL;
    if (!(flags & (MF_SYSMENU | MF_POPUP)))
      message = LoadString(item);
    statusbar->SetText(message);
  }
  return default_return_value;
}


// 点
int lgMainWindow::wmNotify(int id, NMHDR *nmhdr)
{
  switch (nmhdr->code)
  {
    case TTN_NEEDTEXT: // ToolTip eLXg̗v
      return wmNotify_TtnNeedText((TOOLTIPTEXT *)nmhdr);
    case TTN_POP: // ToolTip 
      return wmNotify_TtnPop(nmhdr);
  }
  return default_return_value;
}


// ToolTip eLXg̗v
int lgMainWindow::wmNotify_TtnNeedText(TOOLTIPTEXT *ttt)
{
  ttt->hinst    = lgWindows::hInst();
  ttt->lpszText = MAKEINTRESOURCE(ttt->hdr.idFrom);
  if (statusbar)
    statusbar->SetText(LoadString(ttt->hdr.idFrom));
  return default_return_value;
}


// ToolTip 
int lgMainWindow::wmNotify_TtnPop(NMHDR *nmhdr)
{
  if (statusbar)
    statusbar->SetText(NULL);
  return default_return_value;
}


// EBhETCYω
int lgMainWindow::wmSize(int size_type, int width, int height)
{
  if (toolbar)
    toolbar->SendMessage(WM_SIZE, size_type, MAKELONG(width, height));
  if (statusbar)
    statusbar->SendMessage(WM_SIZE, size_type, MAKELONG(width, height));
  return default_return_value;
}


// VXeJ[ω
int lgMainWindow::wmSysColorChange(void)
{
  if (lgCtl3d::ColorChange)
    lgCtl3d::ColorChange();
  if (toolbar)
    toolbar->SendMessage(WM_SYSCOLORCHANGE, 0, 0);
  return default_return_value;
}
