/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgcRichEdit.cxx


#include	<crtdbg.h>

#include	"lgcRichEdit.h"
#include	"WinDLL.h"


map<HWND, CHARRANGE>	lgcRichEdit::selrange;
HANDLE					lgcRichEdit::selrange_mutex = CreateMutex(NULL, FALSE, NULL);

// sCfbNX擾
int lgcRichEdit::GetLineEndIndex(int line_index)
{
	int char_index = CharFromLine(line_index);
	return char_index + GetLineLengthFromChar(char_index);
}


// Ŏw肵͈͂̃eLXg擾
int lgcRichEdit::GetTextRange(int cpmin, int cpmax, wchar_t *buf)
{
	char *mbsbuf = (char *)_alloca(cpmax - cpmin + 1);
	int len = GetTextRange(cpmin, cpmax, mbsbuf);
	return mbstowcs(buf, mbsbuf, len + 1);
}


// ԍŌ֍s
int lgcRichEdit::MoveCaretToTheLast(void)
{
	if (!lastcharindex_get){
		//lastcharindex_get = true;
		lastcharindex = CharFromLine(GetLineCount() - 1);
		lastcharindex += GetLineLengthFromChar(lastcharindex);
	}
	MoveCaret(lastcharindex);
	return lastcharindex;
}

int lgcRichEdit::SuperMoveCaretToTheLast(void)
{
	if (!lastcharindex_get){
		//lastcharindex_get = true;
		lastcharindex = CharFromLine(GetLineCount() - 1);
		lastcharindex += GetLineLengthFromChar(lastcharindex);
	}
	SuperMoveCaret(lastcharindex);
	return lastcharindex;
}


// ݑIĂ͈͂̃eLXg擾 (s=CR)
LRESULT lgcRichEdit::GetSelText(wchar_t *buf)
{
	int min, max;
	GetSel(&min, &max);
	char *mbsbuf = (char *)_alloca(max - min + 3);
	int len = GetSelText(mbsbuf);
	return mbstowcs(buf, mbsbuf, len + 1);
}


// ݑIĂ͈͂̃eLXgu
void lgcRichEdit::ReplaceSel(const wchar_t *str, BOOL can_undo)
{
	if (is_wide()) smW(EM_REPLACESEL, can_undo, (LPARAM)str);
	else {
		int len = wcslen(str);
		char *mbsbuf = (char *)_alloca((len + 1) * 2);
		wcstombs(mbsbuf, str, (len + 1) * 2);
		ReplaceSel(mbsbuf, can_undo);
	}
}


// s̐擪擾
int lgcRichEdit::BeginingOfLineCharFromChar(int char_index)
{
	int start_index = CharFromLine(LineFromChar(char_index));

	// Waffle 0.2.2beta6: Win2k Ő擪oOC
	//   special thanks to: TYM
	while (0 <= start_index - 1) {
		char buf[16] = "  ";
		GetTextRange(start_index-1, start_index, buf);
		if (buf[1] == '\r' || buf[0] == '\r') break;
		// Waffle 0.2.0f-Rev.C: Win2k s\oOCB
		//   Windows2000 ŕsɂ܂ꍇł{ꕶ̏ꍇAstart_index - 1 
		//   SR start_index Ȃ炵B
		start_index--;
	}

	return start_index;
}


// s̍Ō擾 (s̐擪CfbNXKv)
int lgcRichEdit::EndOfLineCharFromChar(int line_start_index)
{
	int end_index = line_start_index + GetLineLengthFromChar(line_start_index);

	while (1) {
		char buf[16] = "  ";
		int len;
		len = GetTextRange(end_index, end_index + 2, buf);
		if (len < 2) {
			end_index += len;
			break;
		}
		if (buf[0] == '\r') break;
		end_index++;
	}
	return end_index;
}


// Jbĝs̓e擾
char *lgcRichEdit::newGetLineA(int *start_index_r, int *end_index_r)
{
	int char_index  = GetCaretIndex();
	int start_index;
	int end_index;

	start_index = BeginingOfLineCharFromChar(char_index);
	end_index   = EndOfLineCharFromChar(start_index);

	if (start_index_r) *start_index_r = start_index;
	if (end_index_r) *end_index_r = end_index;
	if (end_index > start_index) end_index += 1;

	int size = (end_index - start_index + 3) * 2;
	char *line = new char[size];

	end_index = GetTextRange(start_index, end_index, line);
	line[end_index] = '\0';
	if (end_index < 2 || !(line[end_index - 2] == '\r' && line[end_index - 1] == '\n')) strcat(line, "\r\n");

	return line;
}


wchar_t *lgcRichEdit::newGetLineW(int *start_index_r, int *end_index_r)
{
	char *line = newGetLineA(start_index_r, end_index_r);
	if (!line) return NULL;
	size_t size = mbstowcs(NULL, line, strlen(line) + 1);
	if (size <= 0) {
		delete [] line;
		return NULL;
	}
	wchar_t *wcsline = new wchar_t[size + 1];
	mbstowcs(wcsline, line, size + 1);
	delete [] line;
	return wcsline;
}
