/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgcRichEdit

#pragma	once


#include	"lgWindows.h"
#include	<RichEdit.h>

#include	<map>
using namespace std;

// UNICODE ɑΉĂ̂ EM_REPLACESEL ȂĂЂǂ(T_T)


class lgcRichEdit : public lgWindow
{
	BOOL is_wide(void) { return lgWindows::IsNT(); }

	inline LRESULT smA(UINT message, WPARAM wParam = 0, LPARAM lParam = 0) { return SendMessageA(Hwnd(), message, wParam, lParam); }
  
	inline LRESULT smW(UINT message, WPARAM wParam = 0, LPARAM lParam = 0) { return SendMessageW(Hwnd(), message, wParam, lParam); }

public:

	bool	lastcharindex_get;							// 1xłŏICfbNX擾
	int	lastcharindex;								// 擾ꂽŏICfbNX

	lgcRichEdit(HWND _hwnd) : lgWindow(_hwnd) {
		lastcharindex_get = false; lastcharindex = 0;
		// EN_LINK Mݒ (URL ΍)
		SetEventMask(ENM_LINK | ENM_SELCHANGE);
	}
	~lgcRichEdit() { }

	//// Formating (tH[}bgƌ葮(Agr[g)ł)

	// ݂̃̕tH[}bg()擾
	DWORD GetCharFormat(CHARFORMAT *cf, BOOL is_selection = FALSE) { return (DWORD)smA(EM_GETCHARFORMAT, is_selection, (LPARAM)cf); }

	// ݂̃̕tH[}bg()ݒ
	BOOL SetCharFormat(CHARFORMAT *cf, UINT flags = SCF_SELECTION) { return (BOOL)smA(EM_SETCHARFORMAT, flags, (LPARAM)cf); }

	// ݂̒ĩtH[}bg擾
	DWORD GetParaFormat(PARAFORMAT *pf) { return (DWORD)smA(EM_GETPARAFORMAT, 0, (LPARAM)pf); }
	// ݂̒ĩtH[}bgݒ
	BOOL SetParaFormat(PARAFORMAT *pf) { return (BOOL)smA(EM_SETPARAFORMAT, 0, (LPARAM)pf); }

	// tH[}bg`擾
	void GetRect(RECT *rc) { smA(EM_GETRECT, 0, (LPARAM)rc); }
	// tH[}bg`ݒ
	void SetRect(RECT *rc) { smA(EM_SETRECT, 0, (LPARAM)rc); }

	// wiFZbg
	COLORREF SetBackgroundColor(COLORREF color, BOOL does_use_sys_color = FALSE) { return (COLORREF)smA(EM_SETBKGNDCOLOR, does_use_sys_color, color); }
  
//// Selection and Hit Testing
  
	// W當̈ʒuZo
	BOOL CharFromPos(int x, int y, int *char_index, int *line_index)
	{
		LPARAM r = smA(EM_CHARFROMPOS, 0, MAKELPARAM(x, y));
		if (char_index) *char_index = LOWORD(r);
		if (line_index) *line_index = HIWORD(r);
		return (int)r != -1;
	}
	// ̈ʒuWZo
	void PosFromChar(int char_index, int *x, int *y)
	{
		LPARAM r = smA(EM_POSFROMCHAR, char_index);
		if (x) *x = LOWORD(r);
		if (y) *y = HIWORD(r);
	}

	// ݑIĂ͈͂擾
	void GetSel(CHARRANGE *cr) { smA(EM_EXGETSEL, 0, (LPARAM)cr); }
	// ݑIĂ͈͂ݒ
	int SetSel(CHARRANGE *cr) { return (int)smA(EM_EXSETSEL, 0, (LPARAM)cr); }

//// I͈͎

	static map<HWND, CHARRANGE>	selrange;

private:
	static HANDLE	selrange_mutex;
public:

	static void lockSelrange() { WaitForSingleObject(selrange_mutex, INFINITE); }
	static void unlockSelrange() { ReleaseMutex(selrange_mutex); }

	int SuperSetSel(CHARRANGE* sr) {
		lockSelrange();
		map<HWND, CHARRANGE>::iterator p = selrange.find(Hwnd());
		_ASSERT(p == selrange.end());
		selrange.insert(pair<HWND, CHARRANGE>(Hwnd(), *sr));
		unlockSelrange();
		return (int)smA(EM_EXSETSEL, 0, (LPARAM)sr);
	}
	int SuperSetSel(int cpmin, int cpmax)
	{
		CHARRANGE cr;
		cr.cpMin = cpmin;
		cr.cpMax = cpmax;
		return SuperSetSel(&cr);
	}
	void ReleaseSetSel() {
		lockSelrange();
		map<HWND, CHARRANGE>::iterator p = selrange.find(Hwnd());
		_ASSERT(p != selrange.end());
		selrange.erase(p);
		unlockSelrange();
	}

	// ԏ̍s擾
	int GetFirstVisibleLine(void) { return (int)smA(EM_GETFIRSTVISIBLELINE); }
	// ÏB
	void HideSelection(BOOL does_hide, BOOL does_change_style)
	{ smA(EM_HIDESELECTION, does_hide, does_change_style); }
	// Ï̎
	int GetSelectionType(void) { return (int)smA(EM_SELECTIONTYPE); }

//// Text Operations

	// ő啶̎擾
	int GetTextLimit(void) { return (int)smA(EM_GETLIMITTEXT); }
	// ő啶̐ݒ
	void SetTextLimit(int text_max = 0) { smA(EM_EXLIMITTEXT, 0, text_max); }
	void SetTextLimitMaximum(void) { SetTextLimit(); }

	// eLXǧ
	int FindTextA(FINDTEXT *ft, UINT flags = 0) { return (int)smA(EM_FINDTEXT, (UINT)flags, (LPARAM)ft); }
	int FindTextW(FINDTEXTEXW *ftw, UINT flags = 0) { return (int)smW(EM_FINDTEXTEXW, (UINT)flags, (LPARAM)ftw); }
	// ݑIĂ͈͂̃eLXg擾 (s=CR)
	LRESULT GetSelText(char *buf) { return smA(EM_GETSELTEXT, 0, (LPARAM)buf); }
	LRESULT GetSelText(wchar_t *buf);
	// Ŏw肵͈͂̃eLXg擾
	int GetTextRangeA(TEXTRANGE *tr) { return (int)smA(EM_GETTEXTRANGE, 0, (LPARAM)tr); }
	// ݑIĂ͈͂̃eLXgu
	void ReplaceSel(const char *str, BOOL can_undo = TRUE) { smA(EM_REPLACESEL, can_undo, (LPARAM)str); }
	void ReplaceSel(const wchar_t *str, BOOL can_undo = TRUE);
	void Insert(const char *str, BOOL can_undo = TRUE) { ReplaceSel(str, can_undo); }
	void Insert(const wchar_t *str, BOOL can_undo = TRUE) { ReplaceSel(str, can_undo); }

//// Word and Line Breaks

	// P̋؂
	int FindWordBreak(UINT code, int start_index) { return (int)smA(EM_FINDWORDBREAK, code, start_index); }

	// P̋؂^֐
	EDITWORDBREAKPROC GetWordBreakProc(void) { return (EDITWORDBREAKPROC)smA(EM_GETWORDBREAKPROC); }
	void SetWordBreakProc(EDITWORDBREAKPROC ewbprc) { smA(EM_SETWORDBREAKPROC, 0, (LPARAM)ewbprc); }
	EDITWORDBREAKPROCEX GetWordBreakProcEx(void) { return (EDITWORDBREAKPROCEX)smA(EM_GETWORDBREAKPROCEX); }
	void SetWordBreakProcEX(EDITWORDBREAKPROCEX ewbprc) { smA(EM_SETWORDBREAKPROCEX, 0, (LPARAM)ewbprc); }

//// Lines and Scrolling

	// s̓e擾
	int GetLine(int line, char *buf) { return (int)smA(EM_GETLINE, line, (LPARAM)buf); }
	// s邩
	int GetLineCount(void) { return (int)smA(EM_GETLINECOUNT); }
	// XN[o[̂܂݂̈ʒuԂ
	int GetThumb(void) { return (int)smA(EM_GETTHUMB); }
	// ̈ʒu猻݂̍sԂ
	int LineFromChar(int char_index) { return (int)smA(EM_EXLINEFROMCHAR, 0, char_index); }
	// ̍s̐擪̃̕CfbNXԂ
	int LineIndex(int line) { return (int)smA(EM_LINEINDEX, line, 0); }
	int CharFromLine(int line) { return LineIndex(line); }
	// ̕܂ލs̕𐔂
	int LineLength(int char_index) { return (int)smA(EM_LINELENGTH, char_index); }
	int GetLineLengthFromChar(int char_index) { return LineLength(char_index); }
	int GetLineLengthFromLine(int line_index) { return LineLength(CharFromLine(line_index)); }
	// w肵^sXN[
	BOOL LineScroll(int dx, int dy) { return (BOOL)smA(EM_LINESCROLL, dx, dy); }
	// XN[
	LRESULT Scroll(UINT command) { return smA(EM_SCROLL, command); }
	// Jbg悤ɃXN[
	BOOL ScrollCaret(void) { return (BOOL)smA(EM_SCROLLCARET); }

//// Editing Operations

	// Nbv{[h̃f[^y[Xgł邩ǂ
	BOOL CanPaste(UINT format = 0) { return (BOOL)smA(EM_CANPASTE, format); }
	// UNDO \ǂ
	BOOL CanUndo(void) { return (BOOL)smA(EM_CANUNDO); }
	// UNDO obt@NA
	void EmptyUndoBuffer(void) { smA(EM_EMPTYUNDOBUFFER); }
	// Nbv{[h̃f[^y[Xg
	void PasteSpecial(UINT format = 0) { smA(EM_PASTESPECIAL, format); }
	// UNDO
	BOOL Undo(void) { return (BOOL)smA(EM_UNDO); }
  
//// Streams

	// Xg[̃f[^Ńb`GfBbgRg[̃f[^u
	int StreamIn(UINT format, EDITSTREAM *stream) { return (int)smA(EM_STREAMIN, format, (LPARAM)stream); }
	// b`GfBbgRg[̃f[^Xg[ɏo
	int StreamOut(UINT format, EDITSTREAM *stream) { return (int)smA(EM_STREAMOUT, format, (LPARAM)stream); }

//// Printing

	BOOL DisplayBand(RECT *rc) { return (BOOL)smA(EM_DISPLAYBAND, 0, (LPARAM)rc); }
	int FormatRange(BOOL does_render, FORMATRANGE *fr) { return (int)smA(EM_FORMATRANGE, does_render, (LPARAM)fr); }
	BOOL SetTargetDevice(HDC target, int line_width) { return (BOOL)smA(EM_SETTARGETDEVICE, (WPARAM)target, (int)line_width); }

//// Bottomless Rich Edit Controls

//// OLE Interfaces

//// Miscellaneous

	// Cxg}XN擾
	DWORD GetEventMask(void) { return (DWORD)smA(EM_GETEVENTMASK); }
	// Cxg}XN̐ݒ
	DWORD SetEventMask(DWORD event_mask) { return (BOOL)smA(EM_SETEVENTMASK, 0, event_mask); }

#if 0	// RichEdit2.0/3.0Ŕp~ꂽbZ[W
	// IME composition color 擾(ASIA)
	BOOL GetIMEColor(COMPCOLOR *cc) { return (BOOL)smA(EM_GETIMECOLOR, 0, (LPARAM)cc); }
	// IME composition color ̐ݒ(ASIA)
	BOOL SetIMEColor(COMPCOLOR *cc) { return (BOOL)smA(EM_SETIMECOLOR, 0, (LPARAM)cc); }

	// IME ̃IvV𓾂(ASIA)
	UINT GetIMEOptions(void) { return (UINT)smA(EM_GETIMEOPTIONS); }
	// IME ̃IvV̐ݒ(ASIA)
	BOOL SetIMEOptions(int options) { return (BOOL)smA(EM_SETIMEOPTIONS, 0, options); }
#endif

	// eɕύXꂽǂ
	BOOL GetModify(void) { return (BOOL)smA(EM_GETMODIFY); }
	BOOL HasModified(void) { return GetModify(); }
	// CtO̐ݒ
	void SetModify(BOOL is_modified = TRUE) { smA(EM_SETMODIFY, is_modified); }

	// ݕsǂ
	BOOL GetReadOnly(void) { return (BOOL)(GetWindowLongPtr(Hwnd(), GWL_STYLE) & ES_READONLY); }
	BOOL DoesReadOnly(void) { return GetReadOnly(); }
	// ݕs̐ݒ
	BOOL SetReadOnly(BOOL does_readonly = TRUE) { return (BOOL)smA(EM_SETREADONLY, does_readonly); }

	// IvV𓾂
	UINT GetOptions(void) { return (UINT)smA(EM_GETOPTIONS); }
	// IvV̐ݒ
	void SetOptions(UINT operation, UINT options) { smA(EM_SETOPTIONS, operation, options); }

	// ݂֑̋𓾂(ASIA)
	BOOL GetPunctuation(UINT type, PUNCTUATION *p) { return (BOOL)smA(EM_GETPUNCTUATION, type, (LPARAM)p); }
	// ݂֑̋̐ݒ(ASIA)
	BOOL SetPunctuation(UINT type, PUNCTUATION *p) { return (BOOL)smA(EM_SETPUNCTUATION, type, (LPARAM)p); }

#if 0	// RichEdit2.0/3.0Ŕp~ꂽbZ[W
	// [hbv[h̎擾(ASIA)
	UINT GetWordWrapMode(void) { return (UINT)smA(EM_GETWORDWRAPMODE); }
	// [hbv[h̐ݒ(ASIA)
	UINT SetWordWrapMode(UINT options) { return (UINT)smA(EM_SETWORDWRAPMODE, options); }
#endif

/// 

	// Jbg̈ʒu擾
	int GetCaretIndex(void)
	{
		CHARRANGE cr;
		GetSel(&cr);
		return cr.cpMax;
	}

	// Jbgړ
	int MoveCaret(int char_index)
	{
		CHARRANGE cr;
		cr.cpMin = cr.cpMax = char_index;
		return SetSel(&cr);
	}

	int SuperMoveCaret(int char_index)
	{
		CHARRANGE cr;
		cr.cpMin = cr.cpMax = char_index;
		return SuperSetSel(&cr);
	}

	// ݑIĂ͈͂擾
	void GetSel(int *cpmin, int *cpmax)
	{
		CHARRANGE cr;
		GetSel(&cr);
		if (cpmin) *cpmin = cr.cpMin;
		if (cpmax) *cpmax = cr.cpMax;
	}

	// ݑIĂ͈͂ݒ
	int SetSel(int cpmin, int cpmax)
	{
		CHARRANGE cr;
		cr.cpMin = cpmin;
		cr.cpMax = cpmax;
		return SetSel(&cr);
	}


	// IĂ邩ǂ
	BOOL IsSelected(void)
	{
		CHARRANGE cr;
		GetSel(&cr);
		return cr.cpMin < cr.cpMax;
	}

	// Ŏw肵͈͂̃eLXg擾
	int GetTextRange(int cpmin, int cpmax, char *buf)
	{
		TEXTRANGE tr;
		tr.lpstrText  = buf;
		tr.chrg.cpMin = cpmin;
		tr.chrg.cpMax = cpmax;
		return GetTextRangeA(&tr);
	}

	int GetTextRange(int cpmin, int cpmax, wchar_t *buf);

	// sCfbNX擾
	int GetLineEndIndex(int line_index);

	// ԍŌ֍s
	int MoveCaretToTheLast(void);
	int SuperMoveCaretToTheLast(void);

	// s̐擪擾
	int BeginingOfLineCharFromChar(int char_index);

	// s̍Ō擾 (s̐擪CfbNXKv)
	int EndOfLineCharFromChar(int line_start_index);

	// Jbĝs̓e擾
	char *newGetLineA(int *start_index_r, int *end_index_r);
	wchar_t *newGetLineW(int *start_index_r, int *end_index_r);
    
	// ҏW
	void Cut   (void) { smA(WM_CUT  , 0, 0); } // Cut
	void Copy  (void) { smA(WM_COPY , 0, 0); } // Copy
	void Paste (void) { smA(WM_PASTE, 0, 0); } // Paste		// Waffle 0.2.0: RgO܂
	void Clear (void) { smA(WM_CLEAR, 0, 0); } // Clear
	void Delete(void) { Clear(); }             // Clear

	enum
	{
		WM_APP_IsInIsearchMode   = WM_APP + 100,
		WM_APP_SelectKeyBinding  = WM_APP + 101,
		WM_APP_GetKeyBindingsMap = WM_APP + 102,
	};

#ifdef USE_EMACS_KEYBIND
	enum KeyBinding { KeyBindingEmacs = 1, KeyBindingWindows = 2 };
  
	// Emacs binding Lɂ
	void EnableEmacsBinding(lgcStatusbar *statusbar);
#endif

	//  isearch ǂ
	BOOL IsInIsearchMode(void) { return (BOOL)smA(WM_APP_IsInIsearchMode); }

#ifdef USE_EMACS_KEYBIND
	// Key binding I
	BOOL SelectKeyBinding(KeyBinding key_binding)
	{
		return (BOOL)smA(WM_APP_SelectKeyBinding, (WPARAM)key_binding);
	}

	// Key bingings map 擾
	// 'E' : emacs_keymap
	// 'W' : windows_keymap
	// 'C' : ctrl_c_keymap
	// 'X' : ctrl_x_keymap
	// 'I' : isearch_keymap
	lgKeyBindingsMap *GetKeyBindingsMap(char which_keymap)
	{
		return (lgKeyBindingsMap *)smA(WM_APP_GetKeyBindingsMap, (WPARAM)which_keymap);
	}
#endif

	// Se폜
	void clearBuffer ()
	{
		int		i = MoveCaretToTheLast();
		SetSel(0, i);
		ReplaceSel(L"", FALSE);
	}

public:
};
